/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 4 "qmparse.y" /* yacc.c:339  */


/* qmparse.y: Q machine expression parser */

/* Special case constructs (unary minus) and dangling else cause a number of
   parsing conflicts which are resolved correctly. */

/*  Q eQuational Programming System
    Copyright (c) 1991-2002 by Albert Graef
    <ag@muwiinfa.geschichte.uni-mainz.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/* make sure we have bison */

#ifndef YYBISON
#error "Sorry, this program requires bison."
#endif

#include "qdefs.h"

extern char *prompt, *prompt2, *prompt3;
extern int pmode;

static char		signon[] = Q_SIGNON;
static char		copying[] = COPYING;

static char *psource = "";

static char  *save_file = NULL;
static char *base;

static THREAD *thr;

/*

This module implements a parser for Q expressions and the special
constructs (def, undef, etc.) permitted in the interactive evaluation
loop. The parser can be run in four different modes signalled by special
leading tokens:

- STRING: read a single expression from a null-terminated string.

- LINE: read an expression terminated with newline from a file.

- INTERACT: read and evaluate a command (including def's,
  undef's and shell escapes) from a null-terminated string.

- SOURCE: read and evaluate commands from a file

*/

static swap(), pushtern(), pushbin(), pushun(),
  pushlist(int n, int m), pushstream(int n, int m), pushtuple(int n, int m),
  pushgroup(int *n, int *m),
  savepos(), clean();
static init_stats(), fini_stats(), print_stats();
static copyright(), shell(), expression(),
  vardecl(), initializer(), assignment(), unassignment(),
  sethistfile(), sethistsize(), help(), edit(), save_vars(), clear_vars(),
  add_import(), del_import(), clear_imports(), breakpoints(), profile(),
  who(), whos(), whois(), ambiguous(), import_list(), modules();
static strparam(), intparam(), boolparam(), boolstrparam(), allparam(),
  strlist(), printstr();

/* The following is set to compile for the libqint target. */
#ifdef QINT_LIBRARY
#undef USE_READLINE
#endif

#ifndef USE_READLINE
static histwarn();
#endif

#define MAXARGC 1000

#line 157 "qmparse.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    STRING = 258,
    LINE = 259,
    INTERACT = 260,
    SOURCE = 261,
    AS = 262,
    CONST = 263,
    DEF = 264,
    ELSE = 265,
    EXTERN = 266,
    FROM = 267,
    IF = 268,
    IMPORT = 269,
    INCLUDE = 270,
    OTHERWISE = 271,
    PRIVATE = 272,
    PUBLIC = 273,
    SPECIAL = 274,
    THEN = 275,
    TYPE = 276,
    UNDEF = 277,
    VAR = 278,
    VIRTUAL = 279,
    WHERE = 280,
    DOTDOT = 281,
    EQUIV = 282,
    OP0 = 283,
    OP1 = 284,
    OP2 = 285,
    OP3 = 286,
    OP4 = 287,
    OP5 = 288,
    OP6 = 289,
    OP7 = 290,
    OP8 = 291,
    OP9 = 292,
    _DEF_ = 293,
    _UNDEF_ = 294,
    _VAR_ = 295,
    _IMPORT_ = 296,
    _COPYING_ = 297,
    _HELP_ = 298,
    _EDIT_ = 299,
    _PATH_ = 300,
    _PROMPT_ = 301,
    _HISTFILE_ = 302,
    _HISTSIZE_ = 303,
    _CSTACKSIZE_ = 304,
    _STACKSIZE_ = 305,
    _MEMSIZE_ = 306,
    _STATS_ = 307,
    _RUN_ = 308,
    _SAVE_ = 309,
    _LOAD_ = 310,
    _CLEAR_ = 311,
    _PROFILE_ = 312,
    _BREAK_ = 313,
    _TBREAK_ = 314,
    _DEBUG_ = 315,
    _UNPARSE_ = 316,
    _ECHO_ = 317,
    _CHDIR_ = 318,
    _PWD_ = 319,
    _LS_ = 320,
    _WHICH_ = 321,
    _SOURCE_ = 322,
    _WHO_ = 323,
    _WHOS_ = 324,
    _WHOIS_ = 325,
    _IMPORTS_ = 326,
    _MODULES_ = 327,
    _COMPLETION_MATCHES_ = 328,
    _DEC_ = 329,
    _HEX_ = 330,
    _OCT_ = 331,
    _STD_ = 332,
    _SCI_ = 333,
    _FIX_ = 334,
    _FORMAT_ = 335,
    XID = 336,
    QID = 337,
    NID = 338,
    STR = 339,
    INT = 340,
    FLOAT = 341,
    ARG = 342,
    ERRTOK = 343,
    ARGERR = 344,
    STRERR = 345
  };
#endif
/* Tokens.  */
#define STRING 258
#define LINE 259
#define INTERACT 260
#define SOURCE 261
#define AS 262
#define CONST 263
#define DEF 264
#define ELSE 265
#define EXTERN 266
#define FROM 267
#define IF 268
#define IMPORT 269
#define INCLUDE 270
#define OTHERWISE 271
#define PRIVATE 272
#define PUBLIC 273
#define SPECIAL 274
#define THEN 275
#define TYPE 276
#define UNDEF 277
#define VAR 278
#define VIRTUAL 279
#define WHERE 280
#define DOTDOT 281
#define EQUIV 282
#define OP0 283
#define OP1 284
#define OP2 285
#define OP3 286
#define OP4 287
#define OP5 288
#define OP6 289
#define OP7 290
#define OP8 291
#define OP9 292
#define _DEF_ 293
#define _UNDEF_ 294
#define _VAR_ 295
#define _IMPORT_ 296
#define _COPYING_ 297
#define _HELP_ 298
#define _EDIT_ 299
#define _PATH_ 300
#define _PROMPT_ 301
#define _HISTFILE_ 302
#define _HISTSIZE_ 303
#define _CSTACKSIZE_ 304
#define _STACKSIZE_ 305
#define _MEMSIZE_ 306
#define _STATS_ 307
#define _RUN_ 308
#define _SAVE_ 309
#define _LOAD_ 310
#define _CLEAR_ 311
#define _PROFILE_ 312
#define _BREAK_ 313
#define _TBREAK_ 314
#define _DEBUG_ 315
#define _UNPARSE_ 316
#define _ECHO_ 317
#define _CHDIR_ 318
#define _PWD_ 319
#define _LS_ 320
#define _WHICH_ 321
#define _SOURCE_ 322
#define _WHO_ 323
#define _WHOS_ 324
#define _WHOIS_ 325
#define _IMPORTS_ 326
#define _MODULES_ 327
#define _COMPLETION_MATCHES_ 328
#define _DEC_ 329
#define _HEX_ 330
#define _OCT_ 331
#define _STD_ 332
#define _SCI_ 333
#define _FIX_ 334
#define _FORMAT_ 335
#define XID 336
#define QID 337
#define NID 338
#define STR 339
#define INT 340
#define FLOAT 341
#define ARG 342
#define ERRTOK 343
#define ARGERR 344
#define STRERR 345

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 95 "qmparse.y" /* yacc.c:355  */

  int ival;
  mpz_t zval;
  double fval;
  char *sval;
  EXPR *xval;
  struct {
    int n, m;
  } lval;
  struct {
    char **v;
    int c;
  } aval;

#line 392 "qmparse.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 409 "qmparse.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  88
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1795

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  108
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  77
/* YYNRULES -- Number of rules.  */
#define YYNRULES  282
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  424

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   345

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      91,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    92,     2,     2,     2,     2,     2,     2,
      94,    95,     2,     2,    96,   100,    99,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   103,    93,
       2,    97,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   104,    98,   105,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   106,   102,   107,   101,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   160,   160,   161,   162,   164,   165,   167,   171,   172,
     174,   175,   178,   179,   184,   187,   189,   191,   193,   196,
     206,   217,   231,   237,   253,   278,   293,   296,   299,   302,
     309,   325,   332,   348,   355,   371,   380,   390,   399,   409,
     415,   431,   437,   454,   460,   478,   481,   484,   497,   511,
     539,   563,   605,   611,   621,   623,   625,   631,   633,   639,
     655,   668,   670,   672,   674,   680,   689,   695,   710,   716,
     748,   757,   778,   801,   822,   849,   864,   883,   906,   909,
     912,   915,   918,   920,   922,   926,   925,   954,   954,   956,
     981,   981,   983,  1008,  1008,  1010,  1028,  1028,  1030,  1043,
    1043,  1045,  1066,  1066,  1068,  1086,  1086,  1088,  1100,  1100,
    1102,  1116,  1116,  1118,  1118,  1118,  1120,  1120,  1125,  1130,
    1155,  1167,  1189,  1190,  1194,  1195,  1199,  1198,  1203,  1204,
    1208,  1209,  1212,  1216,  1217,  1220,  1224,  1225,  1228,  1230,
    1234,  1235,  1239,  1240,  1247,  1256,  1257,  1261,  1262,  1266,
    1267,  1270,  1271,  1274,  1276,  1280,  1281,  1285,  1288,  1289,
    1296,  1305,  1306,  1310,  1313,  1314,  1318,  1319,  1320,  1323,
    1324,  1326,  1330,  1335,  1338,  1339,  1343,  1348,  1353,  1354,
    1356,  1357,  1358,  1361,  1364,  1365,  1369,  1372,  1373,  1377,
    1378,  1381,  1382,  1386,  1387,  1393,  1394,  1395,  1396,  1400,
    1402,  1406,  1410,  1415,  1418,  1423,  1426,  1431,  1434,  1439,
    1442,  1445,  1450,  1453,  1458,  1461,  1466,  1469,  1476,  1483,
    1484,  1487,  1492,  1495,  1494,  1500,  1503,  1506,  1510,  1513,
    1512,  1519,  1518,  1531,  1534,  1537,  1540,  1545,  1547,  1550,
    1553,  1557,  1560,  1559,  1566,  1565,  1579,  1581,  1584,  1587,
    1591,  1594,  1593,  1600,  1599,  1613,  1617,  1618,  1624,  1626,
    1628,  1633,  1639,  1641,  1646,  1648,  1650,  1655,  1656,  1657,
    1658,  1663,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "LINE", "INTERACT", "SOURCE",
  "AS", "CONST", "DEF", "ELSE", "EXTERN", "FROM", "IF", "IMPORT",
  "INCLUDE", "OTHERWISE", "PRIVATE", "PUBLIC", "SPECIAL", "THEN", "TYPE",
  "UNDEF", "VAR", "VIRTUAL", "WHERE", "DOTDOT", "EQUIV", "OP0", "OP1",
  "OP2", "OP3", "OP4", "OP5", "OP6", "OP7", "OP8", "OP9", "_DEF_",
  "_UNDEF_", "_VAR_", "_IMPORT_", "_COPYING_", "_HELP_", "_EDIT_",
  "_PATH_", "_PROMPT_", "_HISTFILE_", "_HISTSIZE_", "_CSTACKSIZE_",
  "_STACKSIZE_", "_MEMSIZE_", "_STATS_", "_RUN_", "_SAVE_", "_LOAD_",
  "_CLEAR_", "_PROFILE_", "_BREAK_", "_TBREAK_", "_DEBUG_", "_UNPARSE_",
  "_ECHO_", "_CHDIR_", "_PWD_", "_LS_", "_WHICH_", "_SOURCE_", "_WHO_",
  "_WHOS_", "_WHOIS_", "_IMPORTS_", "_MODULES_", "_COMPLETION_MATCHES_",
  "_DEC_", "_HEX_", "_OCT_", "_STD_", "_SCI_", "_FIX_", "_FORMAT_", "XID",
  "QID", "NID", "STR", "INT", "FLOAT", "ARG", "ERRTOK", "ARGERR", "STRERR",
  "'\\n'", "'!'", "';'", "'('", "')'", "','", "'='", "'\\\\'", "'.'",
  "'-'", "'~'", "'|'", "':'", "'['", "']'", "'{'", "'}'", "$accept",
  "source", "input", "commands", "command", "@1", "breaksyms", "breaksym",
  "tbreaksyms", "tbreaksym", "profilesyms", "profilesym", "clearsyms",
  "clearsym", "clearbreaksyms", "clearbreaksym", "clearprofilesyms",
  "clearprofilesym", "whossyms", "whossym", "whoissyms", "whoissym",
  "symbol", "whossymbol", "ID", "opt_arg_list", "arg_list", "arg",
  "vardecls", "vardecl", "$@2", "initializer", "defs", "def", "undefs",
  "undef", "expression0", "lambda0", "sequence0", "cond0", "rightapp0",
  "relation0", "relop0", "expression", "lambda", "sequence", "seqop",
  "cond", "rightapp", "rappop", "relation", "relop", "addition", "addop",
  "multiplication", "mulop", "unary", "unop", "script", "scriptop",
  "composition", "compop", "application", "quoteop", "primary", "$@3",
  "$@4", "@5", "$@6", "@7", "$@8", "@9", "opt_expr", "expr_list1",
  "expr_list2", "expr_list", "op", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    10,    33,    59,    40,    41,    44,    61,    92,    46,
      45,   126,   124,    58,    91,    93,   123,   125
};
# endif

#define YYPACT_NINF -267

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-267)))

#define YYTABLE_NINF -283

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     324,  1108,  1108,   498,   498,    58,  -267,  1490,  -267,  -267,
    -267,  -267,  -267,  -267,  -267,  -267,  -267,   819,  1689,  1516,
    -267,   792,    82,  -267,  -267,    14,  -267,  -267,    41,    42,
      44,  -267,  1490,  -267,    17,   335,  1689,  -267,    -5,  1141,
      48,    21,  -267,  -267,   108,   108,   108,  -267,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   228,   141,   232,
     141,  -267,   108,   108,   108,  -267,  -267,   108,   108,   108,
     206,   206,  -267,  -267,   108,  -267,  -267,  -267,   108,   108,
     108,  -267,  -267,  -267,    13,  -267,  -267,  -267,  -267,    89,
      32,    46,    59,    67,     8,    27,    79,    80,    84,    90,
    -267,    97,   104,  1195,   113,   109,    14,  1490,  1490,    41,
    1490,    60,  1490,    44,  1490,  1689,    17,  1689,   119,  -267,
    1544,  1229,  1257,  -267,  -267,     9,    98,  -267,    81,    94,
    -267,  1285,  -267,  1490,  -267,  -267,   209,  -267,  1490,  1490,
    1490,   202,  1490,  -267,  -267,  -267,  -267,  1689,  1689,  -267,
    -267,  -267,  1490,  1689,   129,  -267,   134,    14,  -267,  -267,
      41,    71,  -267,   136,  -267,  -267,   144,  -267,   108,  -267,
    -267,  -267,  -267,  -267,   108,  -267,  -267,  -267,  -267,  -267,
    -267,  -267,  -267,  -267,   141,   141,   585,   141,  -267,  -267,
    -267,   141,  -267,  -267,   141,  -267,  -267,  -267,   141,  -267,
    -267,   108,  -267,  -267,  -267,   108,  -267,  -267,  -267,  -267,
     585,   206,  -267,  -267,  -267,   206,  -267,  -267,  -267,  -267,
    -267,  -267,   593,  1285,   146,   147,  -267,   197,  -267,   305,
    1108,  -267,  1167,   149,   153,  1315,    37,  1343,  1371,  1402,
      34,  1430,   154,   155,  1576,  1602,  1630,  -267,  1108,  -267,
    -267,  -267,   854,   893,  1108,  -267,  -267,  -267,   679,   706,
    1108,  -267,  -267,  -267,  -267,    44,    26,    44,  -267,  -267,
    -267,   423,   234,  -267,  1662,  1141,  1141,  1457,  1490,  -267,
    -267,  1490,    48,   158,    21,  -267,  -267,   141,  -267,  -267,
     141,  -267,  -267,  -267,  -267,  -267,  -267,   246,   241,  -267,
    -267,  -267,  -267,  -267,  -267,  -267,  -267,   173,  -267,  -267,
    -267,  -267,   176,  -267,  -267,  -267,   262,   920,  -267,  -267,
     -18,  -267,  -267,   167,   178,  1108,  -267,  -267,  -267,  -267,
    -267,  -267,  -267,  -267,  -267,  -267,  -267,  -267,  -267,  -267,
    -267,  -267,  1108,   948,  -267,  -267,  -267,  -267,   170,  1108,
     733,  -267,  -267,   177,  1457,  1141,  -267,  -267,  -267,  -267,
    -267,    26,  -267,  1141,  -267,  -267,   108,  -267,  -267,  -267,
    -267,  -267,  -267,  1285,  -267,   182,   979,  -267,  1006,  1108,
    -267,  1034,  -267,  1065,  1108,  -267,  -267,   122,    65,   185,
    -267,   -22,   186,  -267,   286,  -267,  -267,  -267,  -267,  -267,
    -267,  -267,  -267,  -267,   210,   920,  -267,  -267,  -267,  -267,
     212,  1108,  -267,  1108,  -267,  -267,  -267,  -267,  1457,  -267,
     218,  -267,  -267,  -267
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       7,     0,     0,     0,     0,     0,   255,     0,   183,   194,
     201,   117,   116,   197,   195,   196,   198,     0,     0,     0,
     193,     0,     0,   199,     2,   151,   155,   158,   161,   164,
     169,   174,     0,   178,   184,     0,     0,   191,     3,     0,
       0,     0,   120,    18,    20,    70,    22,   120,    35,    37,
      39,    41,    43,    45,    84,    75,    73,    58,    56,    52,
       0,   120,    64,    66,    48,    47,   120,    68,     0,    80,
       0,     0,    78,    79,     0,    26,    27,    28,    29,    31,
      33,    25,     9,     5,    10,    12,    14,     6,     1,     0,
     167,   157,   163,   168,   173,   177,   183,   186,   190,   194,
     218,   166,   189,     0,   193,     0,   151,     0,     0,   161,
       0,   164,     0,   169,     0,     0,   184,     0,     0,   152,
       0,   179,   180,   181,   237,   264,     0,   246,   264,     0,
     157,     0,   163,     0,   167,   168,   173,   166,     0,     0,
       0,   177,     0,   182,   186,   190,   189,     0,     0,   192,
     202,     4,     0,     0,    16,   130,     0,   136,   140,   142,
     145,   147,   135,    17,   133,   126,    15,   124,    77,   122,
     123,    21,    71,    23,    24,    36,    38,    40,    42,    44,
      46,    85,    76,    74,    60,    59,     0,    61,    96,    98,
     111,    57,    93,    95,    54,    87,    89,    53,    55,    90,
      92,    51,    65,    67,    49,    50,    69,    72,    81,   115,
       0,    82,   105,   107,   113,    83,   108,   110,    19,    30,
      32,    34,     0,     0,   172,   176,   223,     0,   219,     0,
       0,   231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,     0,   154,
     244,   242,     0,     0,     0,   238,   253,   251,     0,     0,
       0,   247,   156,   162,   172,   171,   165,   170,   176,   175,
     185,     0,     0,   137,     0,     0,     0,     0,     0,   149,
     150,     0,     0,   128,     0,   121,   118,    63,   102,   104,
      62,    99,   101,   268,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   267,   273,   269,   272,     0,    97,    94,
      88,    91,     0,   106,   109,    13,   160,     0,   221,   261,
       0,   220,   258,     0,     0,     0,   203,   204,   206,   205,
     208,   210,   207,   209,   211,   212,   213,   215,   214,   216,
     217,   153,     0,     0,   240,   266,   239,   265,     0,     0,
       0,   249,   248,     0,     0,     0,   139,   131,   132,   141,
     146,   148,   134,     0,   127,   125,    86,   103,   100,   270,
     271,   112,   114,     0,   257,     0,     0,   233,     0,     0,
     229,     0,   225,     0,     0,   222,   264,     0,     0,     0,
     241,     0,     0,   250,   144,   138,   129,   119,   159,   224,
     235,   263,   234,   262,     0,     0,   227,   260,   226,   259,
       0,     0,   232,     0,   245,   243,   254,   252,     0,   236,
       0,   228,   143,   230
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -267,  -267,   312,  -267,    95,  -267,  -267,   126,  -267,   125,
    -267,   140,  -267,   150,  -267,    43,  -267,    47,  -267,   128,
    -267,   131,   -51,   -59,    22,  -267,   112,   -19,  -267,    56,
    -267,  -267,  -267,    74,  -267,    68,  -238,    77,  -267,  -266,
      75,  -267,  -267,    -1,   236,   337,   -12,  -127,     3,    -9,
     340,   -14,   -11,    -3,     6,     0,    35,  -267,   -91,     5,
     341,     7,   -95,  -267,    28,  -267,  -267,  -267,  -267,  -267,
    -267,  -267,  -236,  -267,  -267,   -17,  -121
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,    83,    84,    85,   286,   194,   195,   198,   199,
     191,   192,   187,   188,   290,   291,   287,   288,   211,   212,
     215,   216,   189,   213,    23,   366,   168,   285,   166,   167,
     283,   364,   154,   155,   163,   164,   156,   273,   157,   158,
     159,   160,   281,   374,   119,    25,   107,    26,    27,   108,
      28,   110,    29,   140,    30,   142,    31,    32,    33,   115,
      34,   117,    35,    36,    37,   317,   405,   325,   343,   342,
     350,   349,   375,   323,   320,   126,   118
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      24,    38,    86,    86,   262,   129,   111,   193,   196,   200,
      89,   359,   217,   131,   112,   139,   105,   114,   224,   133,
     125,   128,   246,   113,   243,   171,   172,   173,   161,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   358,   147,
     197,   148,   130,   202,   203,   204,   120,   225,   206,   207,
     208,   144,   145,   271,   123,   218,   270,   136,    88,   219,
     220,   221,   162,   149,   150,   307,   141,   143,   136,   134,
     132,   411,   135,   136,   413,   376,   141,   377,   378,   190,
     190,   190,   190,     6,   379,   416,   151,   134,   394,   312,
     135,   136,   214,   214,   232,     7,   316,   238,   279,   236,
     235,   280,   136,  -277,   165,   262,   222,   389,   239,   223,
     233,   234,   250,   241,   392,     8,   146,   395,   240,     9,
     257,   244,  -278,   245,   251,   396,   138,  -268,   266,   334,
      11,    12,   330,   289,   292,   226,   263,   138,   123,   137,
     193,  -274,   138,   196,   265,   277,   267,   200,   120,   242,
     271,   278,   422,   270,  -275,   272,   217,   137,   411,   174,
     237,   413,  -276,    10,    11,    12,    13,    14,    15,   420,
     414,   138,    16,   201,  -279,  -280,    17,   269,   205,  -281,
      18,   274,    19,    20,   256,  -282,    21,   258,    22,   127,
     259,   252,  -267,   380,   253,   169,   260,   170,     6,  -273,
     254,   261,   227,   255,   228,   229,   190,   190,  -272,   190,
       7,   230,   231,   190,   247,   411,   190,   412,   413,   264,
     190,    86,   268,    11,    12,   275,   319,   266,   322,   324,
       8,   276,   282,   214,     9,   186,   289,   214,   263,   292,
     284,  -270,  -271,   265,   327,   267,   398,   341,   328,   336,
     337,   345,   347,   348,   354,   363,   369,   345,   347,   353,
     381,   370,   382,   383,   161,   161,   161,   161,   371,   384,
     361,   372,   373,   385,   149,   390,   269,   399,    10,    11,
      12,    13,    14,    15,   393,   184,   185,    16,    11,    12,
     415,    17,   318,   417,   209,    18,   418,    19,    20,   149,
     210,    21,   274,    22,   162,   419,     6,   421,   387,   190,
      11,    12,   190,   423,    11,    12,    87,   315,     7,   169,
     310,   170,   186,   311,   386,   388,   186,     1,     2,     3,
       4,   309,   391,   368,   367,  -187,     6,   308,     8,   313,
     365,   386,     9,   161,   161,  -187,   314,   397,   386,   357,
     362,   356,   161,   360,   106,  -187,   249,   109,   116,     0,
       0,  -187,  -187,  -187,  -187,  -187,  -187,  -187,     0,  -187,
    -187,     0,     9,     0,     0,   401,     0,   403,   404,     0,
     407,     0,   409,   410,     0,     0,    10,    11,    12,    13,
      14,    15,     0,     0,     0,    16,     0,     0,     0,    17,
     321,     0,     0,    18,     0,    19,    20,   161,     0,    21,
     345,    22,   347,     0,     0,     0,    10,    11,    12,    13,
      14,    15,     0,  -188,     6,    16,  -187,     0,  -187,    17,
    -187,  -187,  -187,  -188,  -187,  -187,    20,  -187,  -187,    21,
    -187,    22,  -187,  -188,     0,     0,     0,     0,     0,  -188,
    -188,  -188,  -188,  -188,  -188,  -188,     0,  -188,  -188,     0,
       9,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    -8,     6,
       0,     0,     0,     0,    10,    11,    12,    13,    14,    15,
       0,     7,     0,    16,  -188,     0,  -188,    17,  -188,  -188,
    -188,     0,  -188,  -188,    20,  -188,  -188,    21,  -188,    22,
    -188,     8,     0,     0,     0,     9,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    10,
      11,    12,    13,    14,    15,     0,     0,     0,    16,     0,
      82,     0,    17,   -11,     6,     0,    18,     0,    19,    20,
       0,     0,    21,     0,    22,     0,     7,     0,     0,     0,
       0,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,     0,     0,     8,     0,     0,     0,
       9,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    10,    11,    12,    13,    14,    15,
       6,     0,   303,    16,   304,   305,   306,    17,     0,     0,
       0,    18,     7,    19,    20,     0,     0,    21,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     6,     0,     0,
       0,     0,     8,     0,     0,     0,     9,     0,     0,     7,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     0,     0,     0,     0,     8,
       0,     0,     0,     9,     0,     0,     7,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      10,    11,    12,    13,    14,    15,     8,     0,     0,    16,
       9,     0,     0,    17,     0,     0,     0,    18,     0,    19,
      20,     0,     0,    21,     0,    22,   351,    10,    11,    12,
      13,    14,    15,     6,     0,     0,    16,     0,     0,     0,
      17,     0,     0,     0,    18,     7,    19,    20,     0,     0,
      21,     0,    22,   352,    10,    11,    12,    13,    14,    15,
       6,     0,     0,    16,     0,     8,     0,    17,     0,     9,
       0,    18,     7,    19,    20,     0,     0,    21,     0,    22,
    -256,     0,     0,     0,     0,     0,    90,    91,    92,    93,
      94,    95,    96,    97,    98,     6,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     7,     0,     0,
       0,     0,     0,    10,    11,    12,    13,    14,    15,     0,
       0,     0,    16,     0,     0,     0,    17,     8,     0,     0,
      18,     9,    19,    20,     6,     0,    21,   124,    22,     0,
      10,    11,    12,    13,    14,    15,     7,     0,     0,    16,
       0,     0,     0,    17,   100,     0,   101,    18,   102,   103,
     104,     6,     0,    21,     0,    22,     8,     0,     0,     0,
       9,     0,     0,     7,     0,    10,    11,    12,    13,    14,
      15,     0,     0,     0,    16,     0,     0,     0,    17,     6,
       0,     0,    18,     8,    19,    20,     0,     9,    21,   344,
      22,     7,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    10,    11,    12,    13,    14,    15,
       6,     8,     0,    16,     0,     9,     0,    17,     0,     0,
       0,    18,     7,    19,    20,     0,     0,    21,   346,    22,
       0,    10,    11,    12,    13,    14,    15,     6,     0,     0,
      16,     0,     8,     0,    17,  -256,     9,     0,    18,     7,
      19,    20,     0,     0,    21,     0,    22,     0,     0,    10,
      11,    12,    13,    14,    15,     6,     0,     0,    16,     8,
       0,     0,    17,     9,     0,     0,    18,     7,    19,    20,
       0,     0,    21,  -256,    22,     0,     0,     0,     0,     0,
      10,    11,    12,    13,    14,    15,     6,     8,     0,    16,
       0,     9,     0,    17,   400,     0,     0,    18,     7,    19,
      20,     0,     0,    21,     0,    22,     0,    10,    11,    12,
      13,    14,    15,     0,     0,     0,    16,     0,     8,     0,
      17,   402,     9,     0,    18,     0,    19,    20,     0,     6,
      21,     0,    22,     0,     0,    10,    11,    12,    13,    14,
      15,     7,     0,     0,    16,     0,     0,     0,    17,   406,
       0,     0,    18,     0,    19,    20,     0,     0,    21,     0,
      22,     8,     6,     0,     0,     9,    10,    11,    12,    13,
      14,    15,     0,     0,   152,    16,     0,     0,     0,    17,
     408,     0,     0,    18,     0,    19,    20,     0,     6,    21,
       0,    22,     0,     0,     8,     0,     0,     0,     9,     0,
       7,     0,     0,     0,     0,     0,     0,     0,     0,    10,
      11,    12,    13,    14,    15,     0,     6,     0,    16,     0,
       8,     0,    17,     0,     9,     0,    18,     0,    19,    20,
       0,     0,    21,     0,    22,     0,     0,     0,     0,     0,
       0,     0,    10,    11,    12,    13,    14,    15,     8,     0,
    -195,    16,     9,     0,     0,    17,     0,     0,     0,   153,
       0,    19,    20,     0,     0,    21,     0,    22,    10,    11,
      12,    13,    14,    15,     0,     0,     0,    16,  -196,     0,
       0,    17,   326,  -195,  -195,     0,  -195,    19,    20,     0,
       0,    21,     0,    22,     0,     0,    10,    11,    12,    13,
     121,   122,     0,     0,     0,    16,     6,     0,     0,    17,
    -269,  -196,  -196,     0,  -196,    19,    20,     0,     7,    21,
       0,    22,     0,     0,     0,     0,     0,     0,     0,     0,
    -195,  -195,  -195,  -195,  -195,  -195,     6,     0,     8,  -195,
       0,     0,     9,  -195,     0,     0,     0,     0,  -195,     0,
    -195,     0,     0,  -195,     0,  -195,     0,     0,  -196,  -196,
    -196,  -196,  -196,  -196,     6,     0,     0,  -196,     8,     0,
       0,  -196,     9,     0,     0,     0,  -196,     0,  -196,     0,
       0,  -196,     0,  -196,     0,     0,    10,    11,    12,    13,
      14,    15,     6,     0,     0,    16,     8,     0,     0,    17,
       9,     0,     0,     0,     0,    19,    20,     0,     0,    21,
       0,    22,     0,     0,     0,     0,    10,    11,    12,    13,
      14,    15,     0,     6,     8,    16,     0,     0,     9,    17,
     329,     0,     0,     0,     0,    19,    20,     0,     0,    21,
       0,    22,     0,     0,    10,    11,    12,    13,    14,    15,
       0,     6,     0,    16,     0,     8,     0,    17,   331,     9,
       0,     0,     0,    19,    20,     0,     0,    21,     0,    22,
       0,     0,    10,    11,    12,    13,    14,    15,     6,     0,
       0,    16,     0,     8,     0,    17,   332,     9,     0,     0,
     152,    19,    20,     0,     0,    21,     0,    22,     0,     0,
       0,     0,     0,    10,    11,    12,    13,    14,    15,     0,
       8,     6,    16,     0,     9,     0,    17,   333,     0,     0,
       0,     0,    19,    20,     0,     0,    21,     0,    22,     0,
       0,    10,    11,    12,    13,    14,    15,     6,     0,     0,
      16,     0,     0,     8,    17,   335,     0,     9,     0,     0,
      19,    20,     0,     0,    21,     0,    22,     0,    10,    11,
      12,    13,    14,    15,     0,     6,     0,    16,     0,     8,
       0,    17,     0,     9,     0,     0,     0,    19,    20,     0,
       0,    21,     0,    22,     0,     0,     0,     0,     0,     0,
       0,    10,    11,    12,    13,    14,    15,     6,     0,     0,
      16,     9,     0,     0,    17,     0,     0,     0,     0,     0,
      19,    20,     0,     0,    21,     0,    22,    10,    11,    12,
      13,   121,   122,     6,     0,     0,    16,     0,     0,     0,
      17,     0,     0,     9,     0,     0,    19,    20,     0,     0,
      21,     0,    22,     0,     0,    10,    11,    12,    13,    14,
      15,     6,     0,     0,    16,     0,     0,     0,    17,     9,
       0,     0,     0,   248,     0,    20,     0,     0,    21,     0,
      22,     0,     0,     0,     0,     0,     0,    10,    11,    12,
      13,    14,    15,     6,     0,     0,    16,     9,     0,     0,
      17,   338,     0,     0,     0,     0,     0,    20,     0,     0,
      21,     0,    22,    10,    11,    12,    13,    14,    15,     0,
       6,     0,    16,     0,     0,     0,    17,   339,     0,     9,
       0,     0,     0,    20,     0,     0,    21,     0,    22,     0,
       0,    10,    11,    12,    13,    14,    15,     0,     0,     0,
      16,     0,     0,     0,    17,   340,     9,     0,     0,     0,
       0,    20,     0,     0,    21,     0,    22,     0,     0,     0,
       0,     0,     0,    10,    11,    12,    13,    14,    15,     0,
       0,     0,    16,     0,     0,     0,    17,     0,     0,     0,
       0,   355,     0,    20,     0,     0,    21,     0,    22,     0,
      10,    11,    12,    13,    14,    15,     0,     0,     0,    16,
       0,     0,     0,    17,     0,     0,     0,     0,     0,     0,
      20,     0,     0,    21,     0,    22
};

static const yytype_int16 yycheck[] =
{
       1,     2,     3,     4,   131,    22,    17,    58,    59,    60,
       7,   277,    71,    25,    17,    29,    17,    17,    10,    28,
      21,    22,   117,    17,   115,    44,    45,    46,    39,    48,
      49,    50,    51,    52,    53,    54,    55,    56,   276,    34,
      59,    34,    28,    62,    63,    64,    18,    20,    67,    68,
      69,    34,    35,   148,    19,    74,   147,    31,     0,    78,
      79,    80,    40,    35,    36,   186,    32,    32,    31,    27,
      29,    93,    30,    31,    96,    93,    32,    95,    96,    57,
      58,    59,    60,     1,   102,   107,    91,    27,   354,   210,
      30,    31,    70,    71,   106,    13,   223,   111,    27,   110,
     109,    30,    31,    95,    83,   232,    93,   343,   111,    20,
     107,   108,   103,   113,   350,    33,    99,   355,   112,    37,
      26,   116,    95,   116,    26,   363,   100,    95,   139,    95,
      82,    83,    95,   184,   185,    26,   133,   100,   103,    97,
     191,    95,   100,   194,   138,   157,   140,   198,   120,   114,
     245,   160,   418,   244,    95,   152,   215,    97,    93,    47,
     100,    96,    95,    81,    82,    83,    84,    85,    86,   405,
     105,   100,    90,    61,    95,    95,    94,   142,    66,    95,
      98,   153,   100,   101,   103,    95,   104,    93,   106,   107,
      96,    93,    95,    26,    96,    87,   102,    89,     1,    95,
     102,   107,    93,   105,    95,    96,   184,   185,    95,   187,
      13,   102,   103,   191,    95,    93,   194,    95,    96,    10,
     198,   222,    20,    82,    83,    96,   227,   238,   229,   230,
      33,    97,    96,   211,    37,    94,   287,   215,   235,   290,
      96,    95,    95,   237,    95,   239,   373,   248,    95,    95,
      95,   252,   253,   254,    20,    97,    10,   258,   259,   260,
      93,    20,    95,    96,   275,   276,   277,   278,    95,   102,
     281,    95,    10,    95,   246,   105,   241,    95,    81,    82,
      83,    84,    85,    86,   107,    57,    58,    90,    82,    83,
     105,    94,    95,   107,    88,    98,    10,   100,   101,   271,
      94,   104,   274,   106,   282,    95,     1,    95,   325,   287,
      82,    83,   290,    95,    82,    83,     4,   222,    13,    87,
     194,    89,    94,   198,   325,   342,    94,     3,     4,     5,
       6,   191,   349,   290,   287,     0,     1,   187,    33,   211,
     284,   342,    37,   354,   355,    10,   215,   366,   349,   275,
     282,   274,   363,   278,    17,    20,   120,    17,    17,    -1,
      -1,    26,    27,    28,    29,    30,    31,    32,    -1,    34,
      35,    -1,    37,    -1,    -1,   376,    -1,   378,   379,    -1,
     381,    -1,   383,   384,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    -1,    -1,    98,    -1,   100,   101,   418,    -1,   104,
     411,   106,   413,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,     0,     1,    90,    91,    -1,    93,    94,
      95,    96,    97,    10,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    20,    -1,    -1,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    31,    32,    -1,    34,    35,    -1,
      37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,     1,
      -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    13,    -1,    90,    91,    -1,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    33,    -1,    -1,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      92,    -1,    94,     0,     1,    -1,    98,    -1,   100,   101,
      -1,    -1,   104,    -1,   106,    -1,    13,    -1,    -1,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    37,    -1,    -1,    -1,    33,    -1,    -1,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
       1,    -1,    97,    90,    99,   100,   101,    94,    -1,    -1,
      -1,    98,    13,   100,   101,    -1,    -1,   104,    -1,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    33,    -1,    -1,    -1,    37,    -1,    -1,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    33,
      -1,    -1,    -1,    37,    -1,    -1,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    33,    -1,    -1,    90,
      37,    -1,    -1,    94,    -1,    -1,    -1,    98,    -1,   100,
     101,    -1,    -1,   104,    -1,   106,   107,    81,    82,    83,
      84,    85,    86,     1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    98,    13,   100,   101,    -1,    -1,
     104,    -1,   106,   107,    81,    82,    83,    84,    85,    86,
       1,    -1,    -1,    90,    -1,    33,    -1,    94,    -1,    37,
      -1,    98,    13,   100,   101,    -1,    -1,   104,    -1,   106,
     107,    -1,    -1,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,     1,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    33,    -1,    -1,
      98,    37,   100,   101,     1,    -1,   104,   105,   106,    -1,
      81,    82,    83,    84,    85,    86,    13,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    -1,    97,    98,    99,   100,
     101,     1,    -1,   104,    -1,   106,    33,    -1,    -1,    -1,
      37,    -1,    -1,    13,    -1,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,     1,
      -1,    -1,    98,    33,   100,   101,    -1,    37,   104,   105,
     106,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
       1,    33,    -1,    90,    -1,    37,    -1,    94,    -1,    -1,
      -1,    98,    13,   100,   101,    -1,    -1,   104,   105,   106,
      -1,    81,    82,    83,    84,    85,    86,     1,    -1,    -1,
      90,    -1,    33,    -1,    94,    95,    37,    -1,    98,    13,
     100,   101,    -1,    -1,   104,    -1,   106,    -1,    -1,    81,
      82,    83,    84,    85,    86,     1,    -1,    -1,    90,    33,
      -1,    -1,    94,    37,    -1,    -1,    98,    13,   100,   101,
      -1,    -1,   104,   105,   106,    -1,    -1,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,     1,    33,    -1,    90,
      -1,    37,    -1,    94,    95,    -1,    -1,    98,    13,   100,
     101,    -1,    -1,   104,    -1,   106,    -1,    81,    82,    83,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    33,    -1,
      94,    95,    37,    -1,    98,    -1,   100,   101,    -1,     1,
     104,    -1,   106,    -1,    -1,    81,    82,    83,    84,    85,
      86,    13,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      -1,    -1,    98,    -1,   100,   101,    -1,    -1,   104,    -1,
     106,    33,     1,    -1,    -1,    37,    81,    82,    83,    84,
      85,    86,    -1,    -1,    13,    90,    -1,    -1,    -1,    94,
      95,    -1,    -1,    98,    -1,   100,   101,    -1,     1,   104,
      -1,   106,    -1,    -1,    33,    -1,    -1,    -1,    37,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,     1,    -1,    90,    -1,
      33,    -1,    94,    -1,    37,    -1,    98,    -1,   100,   101,
      -1,    -1,   104,    -1,   106,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    33,    -1,
       1,    90,    37,    -1,    -1,    94,    -1,    -1,    -1,    98,
      -1,   100,   101,    -1,    -1,   104,    -1,   106,    81,    82,
      83,    84,    85,    86,    -1,    -1,    -1,    90,     1,    -1,
      -1,    94,    95,    34,    35,    -1,    37,   100,   101,    -1,
      -1,   104,    -1,   106,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    90,     1,    -1,    -1,    94,
      95,    34,    35,    -1,    37,   100,   101,    -1,    13,   104,
      -1,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,     1,    -1,    33,    90,
      -1,    -1,    37,    94,    -1,    -1,    -1,    -1,    99,    -1,
     101,    -1,    -1,   104,    -1,   106,    -1,    -1,    81,    82,
      83,    84,    85,    86,     1,    -1,    -1,    90,    33,    -1,
      -1,    94,    37,    -1,    -1,    -1,    99,    -1,   101,    -1,
      -1,   104,    -1,   106,    -1,    -1,    81,    82,    83,    84,
      85,    86,     1,    -1,    -1,    90,    33,    -1,    -1,    94,
      37,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,   104,
      -1,   106,    -1,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,     1,    33,    90,    -1,    -1,    37,    94,
      95,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,   104,
      -1,   106,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,     1,    -1,    90,    -1,    33,    -1,    94,    95,    37,
      -1,    -1,    -1,   100,   101,    -1,    -1,   104,    -1,   106,
      -1,    -1,    81,    82,    83,    84,    85,    86,     1,    -1,
      -1,    90,    -1,    33,    -1,    94,    95,    37,    -1,    -1,
      13,   100,   101,    -1,    -1,   104,    -1,   106,    -1,    -1,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      33,     1,    90,    -1,    37,    -1,    94,    95,    -1,    -1,
      -1,    -1,   100,   101,    -1,    -1,   104,    -1,   106,    -1,
      -1,    81,    82,    83,    84,    85,    86,     1,    -1,    -1,
      90,    -1,    -1,    33,    94,    95,    -1,    37,    -1,    -1,
     100,   101,    -1,    -1,   104,    -1,   106,    -1,    81,    82,
      83,    84,    85,    86,    -1,     1,    -1,    90,    -1,    33,
      -1,    94,    -1,    37,    -1,    -1,    -1,   100,   101,    -1,
      -1,   104,    -1,   106,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,     1,    -1,    -1,
      90,    37,    -1,    -1,    94,    -1,    -1,    -1,    -1,    -1,
     100,   101,    -1,    -1,   104,    -1,   106,    81,    82,    83,
      84,    85,    86,     1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    -1,    -1,    37,    -1,    -1,   100,   101,    -1,    -1,
     104,    -1,   106,    -1,    -1,    81,    82,    83,    84,    85,
      86,     1,    -1,    -1,    90,    -1,    -1,    -1,    94,    37,
      -1,    -1,    -1,    99,    -1,   101,    -1,    -1,   104,    -1,
     106,    -1,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,     1,    -1,    -1,    90,    37,    -1,    -1,
      94,    95,    -1,    -1,    -1,    -1,    -1,   101,    -1,    -1,
     104,    -1,   106,    81,    82,    83,    84,    85,    86,    -1,
       1,    -1,    90,    -1,    -1,    -1,    94,    95,    -1,    37,
      -1,    -1,    -1,   101,    -1,    -1,   104,    -1,   106,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    37,    -1,    -1,    -1,
      -1,   101,    -1,    -1,   104,    -1,   106,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      -1,    99,    -1,   101,    -1,    -1,   104,    -1,   106,    -1,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    -1,    -1,    -1,    -1,    -1,    -1,
     101,    -1,    -1,   104,    -1,   106
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,   109,     1,    13,    33,    37,
      81,    82,    83,    84,    85,    86,    90,    94,    98,   100,
     101,   104,   106,   132,   151,   153,   155,   156,   158,   160,
     162,   164,   165,   166,   168,   170,   171,   172,   151,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    92,   110,   111,   112,   151,   110,     0,   156,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    37,
      95,    97,    99,   100,   101,   151,   153,   154,   157,   158,
     159,   160,   161,   162,   163,   167,   168,   169,   184,   152,
     172,    85,    86,   164,   105,   151,   183,   107,   151,   183,
      28,   154,    29,   157,    27,    30,    31,    97,   100,   159,
     161,    32,   163,   164,    34,    35,    99,   167,   169,   172,
     172,    91,    13,    98,   140,   141,   144,   146,   147,   148,
     149,   160,   132,   142,   143,    83,   136,   137,   134,    87,
      89,   135,   135,   135,   134,   135,   135,   135,   135,   135,
     135,   135,   135,   135,    57,    58,    94,   120,   121,   130,
     132,   118,   119,   130,   114,   115,   130,   135,   116,   117,
     130,   134,   135,   135,   135,   134,   135,   135,   135,    88,
      94,   126,   127,   131,   132,   128,   129,   131,   135,   135,
     135,   135,    93,    20,    10,    20,    26,    93,    95,    96,
     102,   103,   154,   156,   156,   157,   160,   100,   159,   161,
     162,   163,   164,   166,   167,   169,   170,    95,    99,   152,
     103,    26,    93,    96,   102,   105,   103,    26,    93,    96,
     102,   107,   155,   156,    10,   162,   160,   162,    20,   164,
     166,   170,   156,   145,   172,    96,    97,   154,   157,    27,
      30,   150,    96,   138,    96,   135,   113,   124,   125,   130,
     122,   123,   130,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    37,    97,    99,   100,   101,   184,   121,   119,
     115,   117,   184,   127,   129,   112,   155,   173,    95,   151,
     182,    95,   151,   181,   151,   175,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,   151,   177,   176,   105,   151,   105,   151,   151,   179,
     178,   107,   107,   151,    20,    99,   145,   141,   144,   147,
     148,   160,   143,    97,   139,   137,   133,   125,   123,    10,
      20,    95,    95,    10,   151,   180,    93,    95,    96,   102,
      26,    93,    95,    96,   102,    95,   151,   183,   183,   180,
     105,   183,   180,   107,   147,   144,   144,   135,   155,    95,
      95,   151,    95,   151,   151,   174,    95,   151,    95,   151,
     151,    93,    95,    96,   105,   105,   107,   107,    10,    95,
     180,    95,   147,    95
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   108,   109,   109,   109,   109,   109,   109,   110,   110,
     110,   110,   111,   111,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   113,   112,   114,   114,   115,
     116,   116,   117,   118,   118,   119,   120,   120,   121,   122,
     122,   123,   124,   124,   125,   126,   126,   127,   128,   128,
     129,   130,   130,   131,   131,   131,   132,   132,   133,   133,
     134,   134,   135,   135,   136,   136,   138,   137,   139,   139,
     140,   140,   141,   142,   142,   143,   144,   144,   145,   145,
     146,   146,   147,   147,   147,   148,   148,   149,   149,   150,
     150,   151,   151,   152,   152,   153,   153,   154,   155,   155,
     155,   156,   156,   157,   158,   158,   159,   159,   159,   160,
     160,   160,   161,   161,   162,   162,   163,   163,   164,   164,
     164,   164,   164,   165,   166,   166,   167,   168,   168,   169,
     169,   170,   170,   171,   171,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   173,   172,   172,   172,   172,   172,   174,
     172,   175,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   176,   172,   177,   172,   172,   172,   172,   172,
     172,   178,   172,   179,   172,   172,   180,   180,   181,   181,
     181,   182,   182,   182,   183,   183,   183,   184,   184,   184,
     184,   184,   184,   184,   184,   184,   184,   184,   184,   184,
     184,   184,   184
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     3,     2,     2,     0,     0,     1,
       1,     2,     1,     3,     1,     2,     2,     2,     1,     2,
       1,     2,     1,     2,     2,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     1,     2,
       2,     2,     1,     2,     2,     2,     1,     2,     1,     2,
       2,     2,     3,     3,     1,     2,     1,     2,     1,     2,
       1,     2,     2,     1,     2,     1,     2,     2,     1,     1,
       1,     2,     2,     2,     1,     0,     4,     1,     2,     1,
       1,     2,     1,     1,     2,     1,     1,     2,     1,     1,
       2,     1,     1,     2,     1,     1,     2,     1,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     0,     2,
       0,     2,     1,     1,     1,     3,     0,     3,     0,     2,
       1,     3,     3,     1,     3,     1,     1,     2,     3,     2,
       1,     3,     1,     6,     4,     1,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     1,     3,     1,     1,     6,
       4,     1,     3,     1,     1,     3,     1,     1,     1,     1,
       3,     3,     2,     1,     1,     3,     2,     1,     1,     2,
       2,     2,     2,     1,     1,     3,     1,     1,     3,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     2,     3,
       4,     4,     5,     0,     6,     5,     6,     6,     7,     0,
       8,     0,     6,     5,     6,     6,     7,     2,     3,     4,
       4,     5,     0,     6,     0,     6,     2,     3,     4,     4,
       5,     0,     6,     0,     6,     1,     0,     1,     1,     3,
       3,     1,     3,     3,     1,     3,     3,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 163 "qmparse.y" /* yacc.c:1648  */
    { YYACCEPT; }
#line 2102 "qmparse.c" /* yacc.c:1648  */
    break;

  case 7:
#line 167 "qmparse.y" /* yacc.c:1648  */
    { if (pmode != INTERACT && pmode != SOURCE)
				  YYERROR; }
#line 2109 "qmparse.c" /* yacc.c:1648  */
    break;

  case 9:
#line 173 "qmparse.y" /* yacc.c:1648  */
    { shell(); }
#line 2115 "qmparse.c" /* yacc.c:1648  */
    break;

  case 14:
#line 185 "qmparse.y" /* yacc.c:1648  */
    { if (!expression()) YYABORT; }
#line 2121 "qmparse.c" /* yacc.c:1648  */
    break;

  case 18:
#line 194 "qmparse.y" /* yacc.c:1648  */
    { if (!copyright()) YYABORT; }
#line 2127 "qmparse.c" /* yacc.c:1648  */
    break;

  case 19:
#line 197 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    list_completions(s);
    free(s);
  } else
    YYABORT;
}
#line 2140 "qmparse.c" /* yacc.c:1648  */
    break;

  case 20:
#line 207 "qmparse.y" /* yacc.c:1648  */
    {
  int res = 1;
  if (checkbrk) YYABORT;
  if (gflag)
    gcmd("q-help-cmd");
  else
    res = help(NULL);
  if (!res) YYABORT;
}
#line 2154 "qmparse.c" /* yacc.c:1648  */
    break;

  case 21:
#line 218 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    int res = 1;
    if (gflag) gcmd_s("q-help-cmd", s);
    else
      res = help(s);
    free(s);
    if (!res) YYABORT;
  } else
    YYABORT;
}
#line 2171 "qmparse.c" /* yacc.c:1648  */
    break;

  case 22:
#line 232 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  printstr(qpath);
}
#line 2180 "qmparse.c" /* yacc.c:1648  */
    break;

  case 23:
#line 238 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    change_qpath(s);
    free(s);
    if (lt_dlsetsearchpath(qpath)) {
      thr->qmstat = MEM_OVF;
      clean();
      YYABORT;
    }
    if (gflag) gcmd_s("q-path-cmd", qpath);
  } else
    YYABORT;
}
#line 2199 "qmparse.c" /* yacc.c:1648  */
    break;

  case 24:
#line 254 "qmparse.y" /* yacc.c:1648  */
    {
  char **argv = (yyvsp[0].aval).v;
  int argc = (yyvsp[0].aval).c, i;
  if (argc == 0) {
    free(argv);
    if (checkbrk) YYABORT;
    printstr(prompt);
  } else if (argc > 3) {
    for (i = 0; i < argc; i++) free(argv[i]);
    free(argv);
    savepos();
    thr->qmstat = SYNTAX_ERR;
  } else {
    if (prompt) free(prompt);
    prompt = argv[0];
    if (gflag) gcmd_s("q-prompt-cmd", argv[0]);
    new_xprompt();
    if (argc > 1) prompt2 = argv[1];
    if (argc > 2) prompt3 = argv[2];
    free(argv);
  }
  if (!clean()) YYABORT;
}
#line 2227 "qmparse.c" /* yacc.c:1648  */
    break;

  case 25:
#line 279 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  switch (imode) {
  case 0: printf("dec; "); break;
  case 1: printf("hex; "); break;
  case 2: printf("oct; "); break;
  }
  switch (fmode) {
  case 0: printf("std %d\n", fprec); break;
  case 1: printf("sci %d\n", fprec); break;
  case 2: printf("fix %d\n", fprec); break;
  } 
}
#line 2245 "qmparse.c" /* yacc.c:1648  */
    break;

  case 26:
#line 294 "qmparse.y" /* yacc.c:1648  */
    { if (checkbrk) YYABORT; imode = 0; if (gflag) gcmd("q-dec-cmd"); }
#line 2251 "qmparse.c" /* yacc.c:1648  */
    break;

  case 27:
#line 297 "qmparse.y" /* yacc.c:1648  */
    { if (checkbrk) YYABORT; imode = 1; if (gflag) gcmd("q-hex-cmd"); }
#line 2257 "qmparse.c" /* yacc.c:1648  */
    break;

  case 28:
#line 300 "qmparse.y" /* yacc.c:1648  */
    { if (checkbrk) YYABORT; imode = 2; if (gflag) gcmd("q-oct-cmd"); }
#line 2263 "qmparse.c" /* yacc.c:1648  */
    break;

  case 29:
#line 303 "qmparse.y" /* yacc.c:1648  */
    { 
  if (checkbrk) YYABORT;
  fmode = 0; fprec = 15; sprintf(fformat, STDFORMAT, fprec);
  if (gflag) gcmd_i("q-std-cmd", fprec);
}
#line 2273 "qmparse.c" /* yacc.c:1648  */
    break;

  case 30:
#line 310 "qmparse.y" /* yacc.c:1648  */
    {
  long p;
  if (intparam((yyvsp[0].sval), &p)) {
    if (p >= 0) {
      fmode = 0; fprec = p; sprintf(fformat, STDFORMAT, fprec);
      if (gflag) gcmd_i("q-std-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
}
#line 2292 "qmparse.c" /* yacc.c:1648  */
    break;

  case 31:
#line 326 "qmparse.y" /* yacc.c:1648  */
    { 
  if (checkbrk) YYABORT;
  fmode = 1; fprec = 15; sprintf(fformat, SCIFORMAT, fprec);
  if (gflag) gcmd_i("q-sci-cmd", fprec);
}
#line 2302 "qmparse.c" /* yacc.c:1648  */
    break;

  case 32:
#line 333 "qmparse.y" /* yacc.c:1648  */
    {
  long p;
  if (intparam((yyvsp[0].sval), &p)) {
    if (p >= 0) {
      fmode = 1; fprec = p; sprintf(fformat, SCIFORMAT, fprec);
      if (gflag) gcmd_i("q-sci-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
}
#line 2321 "qmparse.c" /* yacc.c:1648  */
    break;

  case 33:
#line 349 "qmparse.y" /* yacc.c:1648  */
    { 
  if (checkbrk) YYABORT;
  fmode = 2; fprec = 2; sprintf(fformat, FIXFORMAT, fprec);
  if (gflag) gcmd_i("q-fix-cmd", fprec);
}
#line 2331 "qmparse.c" /* yacc.c:1648  */
    break;

  case 34:
#line 356 "qmparse.y" /* yacc.c:1648  */
    {
  long p;
  if (intparam((yyvsp[0].sval), &p)) {
    if (p >= 0) {
      fmode = 2; fprec = p; sprintf(fformat, FIXFORMAT, fprec);
      if (gflag) gcmd_i("q-fix-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
}
#line 2350 "qmparse.c" /* yacc.c:1648  */
    break;

  case 35:
#line 372 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
#ifndef USE_READLINE
  histwarn();
#endif
  printstr(histfile);
}
#line 2362 "qmparse.c" /* yacc.c:1648  */
    break;

  case 36:
#line 381 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    sethistfile(s);
    if (gflag) gcmd_s("q-histfile-cmd", s);
  } else
    YYABORT;
}
#line 2375 "qmparse.c" /* yacc.c:1648  */
    break;

  case 37:
#line 391 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
#ifndef USE_READLINE
  histwarn();
#endif
  printf("%d\n", histmax);
}
#line 2387 "qmparse.c" /* yacc.c:1648  */
    break;

  case 38:
#line 400 "qmparse.y" /* yacc.c:1648  */
    {
  long i;
  if (intparam((yyvsp[0].sval), &i)) {
    sethistsize(i);
    if (gflag) gcmd_i("q-histsize-cmd", i);
  } else
    YYABORT;
}
#line 2400 "qmparse.c" /* yacc.c:1648  */
    break;

  case 39:
#line 410 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  printf("%d\n", cstackmax/1024);
}
#line 2409 "qmparse.c" /* yacc.c:1648  */
    break;

  case 40:
#line 416 "qmparse.y" /* yacc.c:1648  */
    {
  long i;
  if (intparam((yyvsp[0].sval), &i)) {
    i *= 1024;
    if (i == 0 || i >= CSTACKMIN) {
      cstackmax = i;
    } else {
      printf("bad C stack size %d, using default\n", i/1024);
      cstackmax = CSTACKMAX;
    }
    if (gflag) gcmd_i("q-cstacksize-cmd", cstackmax);
  } else
    YYABORT;
}
#line 2428 "qmparse.c" /* yacc.c:1648  */
    break;

  case 41:
#line 432 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  printf("%d\n", stackmax);
}
#line 2437 "qmparse.c" /* yacc.c:1648  */
    break;

  case 42:
#line 438 "qmparse.y" /* yacc.c:1648  */
    {
  long i;
  if (intparam((yyvsp[0].sval), &i)) {
    if (i == 0 || i >= STACKMIN) {
      stackmax = i;
    } else {
      printf("bad stack size %d, using default\n", i);
      stackmax = STACKMAX;
    }
    if (gflag) gcmd_i("q-stacksize-cmd", stackmax);
    /* this is needed to have the stack resized properly */
    clean();
  } else
    YYABORT;
}
#line 2457 "qmparse.c" /* yacc.c:1648  */
    break;

  case 43:
#line 455 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  printf("%d\n", memmax);
}
#line 2466 "qmparse.c" /* yacc.c:1648  */
    break;

  case 44:
#line 461 "qmparse.y" /* yacc.c:1648  */
    {
  long i;
  if (intparam((yyvsp[0].sval), &i)) {
    if (i == 0 || i >= MEMMIN) {
      memmax = i;
    } else {
      printf("bad memory size %d, using default\n", i);
      memmax = MEMMAX;
    }
    lastblksz = memmax % XBLKSZ;
    maxnblks = memmax/XBLKSZ+((memmax <= 0||lastblksz==0)?0:1);
    if (lastblksz == 0) lastblksz = XBLKSZ;
    if (gflag) gcmd_i("q-memsize-cmd", memmax);
  } else
    YYABORT;
}
#line 2487 "qmparse.c" /* yacc.c:1648  */
    break;

  case 45:
#line 479 "qmparse.y" /* yacc.c:1648  */
    { if (checkbrk) YYABORT; print_stats(0); }
#line 2493 "qmparse.c" /* yacc.c:1648  */
    break;

  case 46:
#line 482 "qmparse.y" /* yacc.c:1648  */
    { if (allparam((yyvsp[0].sval))) print_stats(1); else YYABORT; }
#line 2499 "qmparse.c" /* yacc.c:1648  */
    break;

  case 47:
#line 485 "qmparse.y" /* yacc.c:1648  */
    {
  char wd[MAXSTRLEN];
  if (checkbrk) YYABORT;
  if (getcwd(wd, MAXSTRLEN)) {
    printstr(wd);
  } else {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
}
#line 2515 "qmparse.c" /* yacc.c:1648  */
    break;

  case 48:
#line 498 "qmparse.y" /* yacc.c:1648  */
    {
  char buf[MAXSTRLEN];
  if (checkbrk) YYABORT;
  if (chdir(expand(buf, "~"))) {
    thr->qmstat = BAD_DIR;
    clean();
    YYABORT;
  } else {
    if (gflag) gcmd_s("q-cd-cmd", buf);
    new_xprompt();
  }
}
#line 2532 "qmparse.c" /* yacc.c:1648  */
    break;

  case 49:
#line 512 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    int res;
    char *buf =
      malloc((MAXSTRLEN+strlen(s)+1)*
	     sizeof(char));
    if (buf)
      expand(buf, s);
    else
      thr->qmstat = MEM_OVF;
    free(s);
    res = clean();
    if (res && buf)
      if (chdir(buf)) {
	thr->qmstat = BAD_DIR;
	res = clean();
      } else {
	if (gflag) gcmd_s("q-cd-cmd", buf);
	new_xprompt();
      }
    if (buf) free(buf);
    if (!res) YYABORT;
  } else
    YYABORT;
}
#line 2563 "qmparse.c" /* yacc.c:1648  */
    break;

  case 50:
#line 541 "qmparse.y" /* yacc.c:1648  */
    {
  static char ls_cmd[] = "ls";
  char **argv = (yyvsp[0].aval).v, *cmd;
  int argc = (yyvsp[0].aval).c, l = 0, i;
  for (i = 0; i < argc; i++)
    l += strlen(argv[i])+1;
  if (!(cmd = (char*)malloc((strlen(ls_cmd)+l+1)*sizeof(char))))
    thr->qmstat = MEM_OVF;
  else {
    strcpy(cmd, ls_cmd);
    for (i = 0; i < argc; i++)
      strcat(strcat(cmd, " "), argv[i]);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  }
  for (i = 0; i < argc; i++) free(argv[i]);
  free(argv);
  if (!clean()) YYABORT;
}
#line 2589 "qmparse.c" /* yacc.c:1648  */
    break;

  case 51:
#line 565 "qmparse.y" /* yacc.c:1648  */
    {
  extern int debug_parse_opts(char*);
  extern char *debug_get_opts(char*);
  char **argv = (yyvsp[0].aval).v, *cmd;
  int argc = (yyvsp[0].aval).c, l = 0, i;
  if (!argc) {
    free(argv);
    if (checkbrk) YYABORT;
    printf("debug is %s\n", debug?"on":"off");
  } else if (argc ==1 && (!strcmp(argv[0],"on") || !strcmp(argv[0],"off"))) {
    int b = !strcmp(argv[0],"on");
    for (i = 0; i < argc; i++) free(argv[i]);
    free(argv);
    debug = thr->debug = b;
    if (gflag) gcmd_b("q-debug-cmd", b);
  } else {
    for (i = 0; i < argc; i++)
      l += strlen(argv[i])+1;
    if (!(cmd = (char*)malloc((l+1)*sizeof(char))))
      thr->qmstat = MEM_OVF;
    else {
      *cmd = 0;
      for (i = 0; i < argc; i++) {
	if (i > 0) strcat(cmd, " ");
	strcat(cmd, argv[i]);
      }
      if (!debug_parse_opts(sys_to_utf8(cmd)))
	thr->qmstat = SYNTAX_ERR;
      else if (gflag) {
	char opts[MAXSTRLEN];
	gcmd_s("q-debug-options-cmd", debug_get_opts(opts));
      }
      free(cmd);
    }
    for (i = 0; i < argc; i++) free(argv[i]);
    free(argv);
    if (!clean()) YYABORT;
  }
}
#line 2633 "qmparse.c" /* yacc.c:1648  */
    break;

  case 52:
#line 606 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  breakpoints();
}
#line 2642 "qmparse.c" /* yacc.c:1648  */
    break;

  case 53:
#line 612 "qmparse.y" /* yacc.c:1648  */
    {
  int b;
  if (boolparam((yyvsp[0].sval), &b)) {
    brkdbg = thr->brkdbg = b;
    if (gflag) gcmd_b("q-break-cmd", b);
  } else
    YYABORT;
}
#line 2655 "qmparse.c" /* yacc.c:1648  */
    break;

  case 56:
#line 626 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  profile();
}
#line 2664 "qmparse.c" /* yacc.c:1648  */
    break;

  case 58:
#line 634 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  clear_vars();
}
#line 2673 "qmparse.c" /* yacc.c:1648  */
    break;

  case 59:
#line 640 "qmparse.y" /* yacc.c:1648  */
    {
  int i;
  if (checkbrk) YYABORT;
  for (i = RESERVED; i < symtbsz+tmptbsz; i++) {
    if (symtb[i].flags & BRK) {
      symtb[i].flags &= ~BRK;
      nbreak--;
    }
    if (symtb[i].flags & TBRK) {
      symtb[i].flags &= ~TBRK;
      nbreak--;
    }
  }
}
#line 2692 "qmparse.c" /* yacc.c:1648  */
    break;

  case 60:
#line 656 "qmparse.y" /* yacc.c:1648  */
    {
  int i;
  if (checkbrk) YYABORT;
  for (i = RESERVED; i < symtbsz+tmptbsz; i++) {
    if (symtb[i].flags & PROF) {
      symtb[i].flags &= ~PROF;
      symtb[i].nredns = 0;
      nprof--;
    }
  }
}
#line 2708 "qmparse.c" /* yacc.c:1648  */
    break;

  case 64:
#line 675 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  printf("unparse is %s\n", unparseflag?"on":"off");
}
#line 2717 "qmparse.c" /* yacc.c:1648  */
    break;

  case 65:
#line 681 "qmparse.y" /* yacc.c:1648  */
    {
  int b;
  if (boolparam((yyvsp[0].sval), &b))
    unparseflag = b;
  else
    YYABORT;
}
#line 2729 "qmparse.c" /* yacc.c:1648  */
    break;

  case 66:
#line 690 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  printf("echo is %s\n", eflag?"on":"off");
}
#line 2738 "qmparse.c" /* yacc.c:1648  */
    break;

  case 67:
#line 696 "qmparse.y" /* yacc.c:1648  */
    {
  int b; char *s;
  if (boolstrparam((yyvsp[0].sval), &b, &s))
    if (!s) {
      eflag = b;
      if (gflag) gcmd_b("q-echo-cmd", b);
    } else {
      printf("%s\n", s);
      free(s);
    }
  else
    YYABORT;
}
#line 2756 "qmparse.c" /* yacc.c:1648  */
    break;

  case 68:
#line 711 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  printstr(which);
}
#line 2765 "qmparse.c" /* yacc.c:1648  */
    break;

  case 69:
#line 717 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    int l0 = strlen(s), l = strlen(qpath)+l0;
    char *buf = malloc((l+3)*sizeof(char));
    char *name = malloc((l+MAXSTRLEN+3)*sizeof(char));
    if (buf && name) {
      absname(name, searchlib(buf, s));
      if (!chkfile(name)) {
	char *t = malloc((l0+3)*sizeof(char));
	if (!t) goto errexit;
	strcat(strcpy(t, s), ".q");
	absname(name, searchlib(buf, t));
	free(t);
      }
      if (chkfile(name))
	printstr(name);
      else
	printf("%s not found\n", s);
    } else {
    errexit:
      thr->qmstat = MEM_OVF;
    }
    clean();
    free(s);
    if (buf) free(buf);
    if (name) free(name);
  } else
    YYABORT;
}
#line 2800 "qmparse.c" /* yacc.c:1648  */
    break;

  case 70:
#line 749 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  if (gflag)
    gcmd_s("q-edit-cmd", which);
  else if (!edit(which))
    YYABORT;
}
#line 2812 "qmparse.c" /* yacc.c:1648  */
    break;

  case 71:
#line 758 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    int res;
    char *buf = malloc((MAXSTRLEN+strlen(s)+1)*sizeof(char));
    if (buf) {
      expand(buf, s);
      if (gflag)
	gcmd_s("q-edit-cmd", buf);
      else
	edit(buf);
    } else
      thr->qmstat = MEM_OVF;
    res = clean();
    free(s); if (buf) free(buf);
    if (!res) YYABORT;
  } else
    YYABORT;
}
#line 2836 "qmparse.c" /* yacc.c:1648  */
    break;

  case 72:
#line 779 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    int l = strlen(qpath)+strlen(s);
    char *buf = malloc((l+1)*sizeof(char));
    if (buf) {
      int res = parsesrc(searchlib(buf, s), 1);
      if (!res) {
	free(buf);
	free(s);
	YYABORT;
      }
    } else
      thr->qmstat = MEM_OVF;
    free(s);
    if (buf) free(buf);
    if (!clean())
      YYABORT;
  } else
    YYABORT;
}
#line 2862 "qmparse.c" /* yacc.c:1648  */
    break;

  case 73:
#line 802 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  if (!save_file)
    save_file = strdup(".q_vars");
  if (!save_file) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  if (chkfile(save_file)) {
    int _eflag = eflag, res;
    printf("loading ");
    printstr(save_file);
    eflag = 0;
    res = parsesrc(save_file, 0);
    eflag = _eflag;
    if (!res) YYABORT;
  }
}
#line 2886 "qmparse.c" /* yacc.c:1648  */
    break;

  case 74:
#line 823 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    char *buf = malloc((strlen(s)+MAXSTRLEN+1)*sizeof(char));
    if (buf) {
      int _eflag = eflag, res;
      eflag = 0;
      res = parsesrc(expand(buf, s), 0);
      eflag = _eflag;
      if (res) {
	if (save_file) free(save_file);
	save_file = buf;
      } else {
	free(buf);
	free(s);
	YYABORT;
      }
    } else
      thr->qmstat = MEM_OVF;
    free(s);
    if (!clean())
      YYABORT;
  } else
    YYABORT;
}
#line 2916 "qmparse.c" /* yacc.c:1648  */
    break;

  case 75:
#line 850 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  if (!save_file)
    save_file = strdup(".q_vars");
  if (!save_file) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  printf("saving ");
  printstr(save_file);
  if (!save_vars(NULL)) YYABORT;
}
#line 2934 "qmparse.c" /* yacc.c:1648  */
    break;

  case 76:
#line 865 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    int res;
    char *buf = malloc((strlen(s)+MAXSTRLEN+1)*sizeof(char));
    if (buf) {
      res = save_vars(expand(buf, s));
      if (!res)	free(buf);
    } else {
      thr->qmstat = MEM_OVF;
      res = 0;
    }
    free(s);
    if (!res) YYABORT;
  } else
    YYABORT;
}
#line 2956 "qmparse.c" /* yacc.c:1648  */
    break;

  case 77:
#line 884 "qmparse.y" /* yacc.c:1648  */
    {
  char **argv = (yyvsp[0].aval).v;
  int count = 0, i, argc = (yyvsp[0].aval).c;
  if (argv && argc > 0) {
    for (i = 0; i < argc; i++) {
      int res;
      if (*argv[i] == '-')
	res = del_import(argv[i]+1);
      else if (*argv[i] == '+')
	res = add_import(strdup(argv[i]+1));
      else
	res = add_import(strdup(argv[i]));
      if (res) count++;
      free(argv[i]);
    }
    free(argv);
    if (count)
      rerun(NULL, 0, NULL);
  } else if (clear_imports())
    rerun(NULL, 0, NULL);
}
#line 2982 "qmparse.c" /* yacc.c:1648  */
    break;

  case 78:
#line 907 "qmparse.y" /* yacc.c:1648  */
    { if (!import_list()) YYABORT; }
#line 2988 "qmparse.c" /* yacc.c:1648  */
    break;

  case 79:
#line 910 "qmparse.y" /* yacc.c:1648  */
    { if (!modules()) YYABORT; }
#line 2994 "qmparse.c" /* yacc.c:1648  */
    break;

  case 80:
#line 913 "qmparse.y" /* yacc.c:1648  */
    { if (!who(0)) YYABORT; }
#line 3000 "qmparse.c" /* yacc.c:1648  */
    break;

  case 81:
#line 916 "qmparse.y" /* yacc.c:1648  */
    { if (!allparam((yyvsp[0].sval)) || !who(1)) YYABORT; }
#line 3006 "qmparse.c" /* yacc.c:1648  */
    break;

  case 84:
#line 923 "qmparse.y" /* yacc.c:1648  */
    { if (checkbrk) YYABORT; rerun(NULL, 0, NULL); }
#line 3012 "qmparse.c" /* yacc.c:1648  */
    break;

  case 85:
#line 926 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if (strparam((yyvsp[0].sval), &s)) {
    (yyval.aval).v = (char**)malloc((MAXARGC+1)*sizeof(char*));
    if (!(yyval.aval).v) {
      thr->qmstat = MEM_OVF;
      free(s);
      clean();
      YYABORT;
    }
    (yyval.aval).v[0] = s;
    (yyval.aval).c = 1;
  } else
    YYABORT;
}
#line 3032 "qmparse.c" /* yacc.c:1648  */
    break;

  case 86:
#line 942 "qmparse.y" /* yacc.c:1648  */
    {
  char **argv = (yyvsp[0].aval).v;
  int argc = (yyvsp[0].aval).c, ret;
  argv[argc] = NULL;
  ret = rerun(*argv, argc, argv);
  while (argc > 0)
    if (argv[argc-1]) free(argv[--argc]);
  if (argv) free(argv);
  if (!ret) YYABORT;
}
#line 3047 "qmparse.c" /* yacc.c:1648  */
    break;

  case 89:
#line 957 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[(yyvsp[0].ival)].flags&VSYM)) {
    if (symtb[(yyvsp[0].ival)].flags & TBRK) {
      symtb[(yyvsp[0].ival)].flags &= ~TBRK;
      nbreak--;
    }
    if (!(symtb[(yyvsp[0].ival)].flags & BRK)) {
      symtb[(yyvsp[0].ival)].flags |= BRK;
      nbreak++;
    }
    if (!brkdbg || !thr->brkdbg) {
      brkdbg = thr->brkdbg = 1;
      if (gflag) gcmd_b("q-break-cmd", 1);
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
#line 3074 "qmparse.c" /* yacc.c:1648  */
    break;

  case 92:
#line 984 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[(yyvsp[0].ival)].flags&VSYM)) {
    if (symtb[(yyvsp[0].ival)].flags & BRK) {
      symtb[(yyvsp[0].ival)].flags &= ~BRK;
      nbreak--;
    }
    if (!(symtb[(yyvsp[0].ival)].flags & TBRK)) {
      symtb[(yyvsp[0].ival)].flags |= TBRK;
      nbreak++;
    }
    if (!brkdbg || !thr->brkdbg) {
      brkdbg = thr->brkdbg = 1;
      if (gflag) gcmd_b("q-break-cmd", 1);
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
#line 3101 "qmparse.c" /* yacc.c:1648  */
    break;

  case 95:
#line 1011 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[(yyvsp[0].ival)].flags&VSYM)) {
    if (!(symtb[(yyvsp[0].ival)].flags & PROF)) {
      symtb[(yyvsp[0].ival)].flags |= PROF;
      symtb[(yyvsp[0].ival)].nredns = 0;
      nprof++;
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
#line 3121 "qmparse.c" /* yacc.c:1648  */
    break;

  case 98:
#line 1031 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[(yyvsp[0].ival)].flags & VSYM)) {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  } else if (!unassignment((yyvsp[0].ival)))
    YYABORT; 
}
#line 3136 "qmparse.c" /* yacc.c:1648  */
    break;

  case 101:
#line 1046 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[(yyvsp[0].ival)].flags & VSYM)) {
    if (symtb[(yyvsp[0].ival)].flags & BRK) {
      symtb[(yyvsp[0].ival)].flags &= ~BRK;
      nbreak--;
    }
    if (symtb[(yyvsp[0].ival)].flags & TBRK) {
      symtb[(yyvsp[0].ival)].flags &= ~TBRK;
      nbreak--;
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
#line 3159 "qmparse.c" /* yacc.c:1648  */
    break;

  case 104:
#line 1069 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[(yyvsp[0].ival)].flags & VSYM)) {
    if (symtb[(yyvsp[0].ival)].flags & PROF) {
      symtb[(yyvsp[0].ival)].flags &= ~PROF;
      symtb[(yyvsp[0].ival)].nredns = 0;
      nprof--;
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
#line 3179 "qmparse.c" /* yacc.c:1648  */
    break;

  case 107:
#line 1088 "qmparse.y" /* yacc.c:1648  */
    { extern char yylastsym[];
                      if (checkbrk) YYABORT;
		      if ((yyvsp[0].ival) == NONE && thr->qmstat == BAD_REF &&
			  *yylastsym) {
			thr->qmstat = OK;
			ambiguous((yyvsp[0].ival), yylastsym);
		      } else if ((yyvsp[0].ival) != NONE) {
			printf("\n");
			whos((yyvsp[0].ival));
		      } else
			YYABORT; }
#line 3195 "qmparse.c" /* yacc.c:1648  */
    break;

  case 110:
#line 1102 "qmparse.y" /* yacc.c:1648  */
    { extern char yylastsym[];
                       if (checkbrk) YYABORT;
		       if ((yyvsp[0].ival) == NONE && thr->qmstat == BAD_REF &&
			   *yylastsym) {
			 thr->qmstat = OK;
			 whois((yyvsp[0].ival), yylastsym);
		       } else if ((yyvsp[0].ival) != NONE && *yylastsym) {
			 whois((yyvsp[0].ival), yylastsym);
		       } else if ((yyvsp[0].ival) != NONE) {
			 printf("\n");
			 whos((yyvsp[0].ival));
		       } else
			 YYABORT; }
#line 3213 "qmparse.c" /* yacc.c:1648  */
    break;

  case 112:
#line 1116 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 3219 "qmparse.c" /* yacc.c:1648  */
    break;

  case 114:
#line 1118 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 3225 "qmparse.c" /* yacc.c:1648  */
    break;

  case 115:
#line 1118 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = NONE; }
#line 3231 "qmparse.c" /* yacc.c:1648  */
    break;

  case 118:
#line 1125 "qmparse.y" /* yacc.c:1648  */
    {
  (yyval.aval) = (yyvsp[0].aval);
}
#line 3239 "qmparse.c" /* yacc.c:1648  */
    break;

  case 119:
#line 1131 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if ((yyvsp[-1].aval).c >= MAXARGC) {
    thr->qmstat = ARGS_ERR;
    while ((yyvsp[-1].aval).c > 0)
      free((yyvsp[-1].aval).v[--(yyvsp[-1].aval).c]);
    free((yyvsp[-1].aval).v);
    clean();
    YYABORT;
  } else if (strparam((yyvsp[0].sval), &s)) {
    (yyvsp[-1].aval).v[(yyvsp[-1].aval).c++] = s;
  } else {
    while ((yyvsp[-1].aval).c > 0)
      free((yyvsp[-1].aval).v[--(yyvsp[-1].aval).c]);
    free((yyvsp[-1].aval).v);
    YYABORT;
  }
  (yyval.aval) = (yyvsp[-1].aval);
}
#line 3263 "qmparse.c" /* yacc.c:1648  */
    break;

  case 120:
#line 1155 "qmparse.y" /* yacc.c:1648  */
    {
  if (checkbrk) YYABORT;
  (yyval.aval).v = (char**)malloc((MAXARGC+1)*sizeof(char*));
  if (!(yyval.aval).v) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  (yyval.aval).c = 0;
}
#line 3278 "qmparse.c" /* yacc.c:1648  */
    break;

  case 121:
#line 1168 "qmparse.y" /* yacc.c:1648  */
    {
  char *s;
  if ((yyvsp[-1].aval).c >= MAXARGC) {
    thr->qmstat = ARGS_ERR;
    while ((yyvsp[-1].aval).c > 0)
      free((yyvsp[-1].aval).v[--(yyvsp[-1].aval).c]);
    free((yyvsp[-1].aval).v);
    clean();
    YYABORT;
  } else if (strparam((yyvsp[0].sval), &s))
    (yyvsp[-1].aval).v[(yyvsp[-1].aval).c++] = s;
  else {
    while ((yyvsp[-1].aval).c > 0)
      free((yyvsp[-1].aval).v[--(yyvsp[-1].aval).c]);
    free((yyvsp[-1].aval).v);
    YYABORT;
  }
  (yyval.aval) = (yyvsp[-1].aval);
}
#line 3302 "qmparse.c" /* yacc.c:1648  */
    break;

  case 123:
#line 1191 "qmparse.y" /* yacc.c:1648  */
    { YYERROR; }
#line 3308 "qmparse.c" /* yacc.c:1648  */
    break;

  case 126:
#line 1199 "qmparse.y" /* yacc.c:1648  */
    { if (!vardecl((yyvsp[0].ival))) YYABORT; }
#line 3314 "qmparse.c" /* yacc.c:1648  */
    break;

  case 129:
#line 1205 "qmparse.y" /* yacc.c:1648  */
    { if (!initializer()) YYABORT; }
#line 3320 "qmparse.c" /* yacc.c:1648  */
    break;

  case 132:
#line 1213 "qmparse.y" /* yacc.c:1648  */
    { if (!assignment()) YYABORT; }
#line 3326 "qmparse.c" /* yacc.c:1648  */
    break;

  case 135:
#line 1221 "qmparse.y" /* yacc.c:1648  */
    { if (!unassignment((yyvsp[0].ival))) YYABORT; }
#line 3332 "qmparse.c" /* yacc.c:1648  */
    break;

  case 138:
#line 1229 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin(LAMBDAOP)) YYABORT; }
#line 3338 "qmparse.c" /* yacc.c:1648  */
    break;

  case 139:
#line 1231 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin(LAMBDAOP)) YYABORT; }
#line 3344 "qmparse.c" /* yacc.c:1648  */
    break;

  case 141:
#line 1236 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3350 "qmparse.c" /* yacc.c:1648  */
    break;

  case 143:
#line 1241 "qmparse.y" /* yacc.c:1648  */
    { static char sym[20];
				  int fno = mksym(strcpy(sym, "cond::ifelse"));
				  if (fno == NONE) {
				    thr->qmstat = SYNTAX_ERR; YYABORT;
				  } else if (!pushtern(fno))
				    YYABORT; }
#line 3361 "qmparse.c" /* yacc.c:1648  */
    break;

  case 144:
#line 1248 "qmparse.y" /* yacc.c:1648  */
    { static char sym[20];
				  int fno = mksym(strcpy(sym, "cond::when"));
				  if (fno == NONE) {
				    thr->qmstat = SYNTAX_ERR; YYABORT;
				  } else if (!pushbin(fno))
				    YYABORT; }
#line 3372 "qmparse.c" /* yacc.c:1648  */
    break;

  case 146:
#line 1258 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3378 "qmparse.c" /* yacc.c:1648  */
    break;

  case 148:
#line 1263 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3384 "qmparse.c" /* yacc.c:1648  */
    break;

  case 149:
#line 1266 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = IDOP; }
#line 3390 "qmparse.c" /* yacc.c:1648  */
    break;

  case 153:
#line 1275 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin(LAMBDAOP)) YYABORT; }
#line 3396 "qmparse.c" /* yacc.c:1648  */
    break;

  case 154:
#line 1277 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin(LAMBDAOP)) YYABORT; }
#line 3402 "qmparse.c" /* yacc.c:1648  */
    break;

  case 156:
#line 1282 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3408 "qmparse.c" /* yacc.c:1648  */
    break;

  case 159:
#line 1290 "qmparse.y" /* yacc.c:1648  */
    { static char sym[20];
				  int fno = mksym(strcpy(sym, "cond::ifelse"));
				  if (fno == NONE) {
				    thr->qmstat = SYNTAX_ERR; YYABORT;
				  } else if (!pushtern(fno))
				    YYABORT; }
#line 3419 "qmparse.c" /* yacc.c:1648  */
    break;

  case 160:
#line 1297 "qmparse.y" /* yacc.c:1648  */
    { static char sym[20];
				  int fno = mksym(strcpy(sym, "cond::when"));
				  if (fno == NONE) {
				    thr->qmstat = SYNTAX_ERR; YYABORT;
				  } else if (!pushbin(fno))
				    YYABORT; }
#line 3430 "qmparse.c" /* yacc.c:1648  */
    break;

  case 162:
#line 1307 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3436 "qmparse.c" /* yacc.c:1648  */
    break;

  case 165:
#line 1315 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3442 "qmparse.c" /* yacc.c:1648  */
    break;

  case 166:
#line 1318 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = EQOP; }
#line 3448 "qmparse.c" /* yacc.c:1648  */
    break;

  case 167:
#line 1319 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = IDOP; }
#line 3454 "qmparse.c" /* yacc.c:1648  */
    break;

  case 170:
#line 1325 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3460 "qmparse.c" /* yacc.c:1648  */
    break;

  case 171:
#line 1327 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin(MINOP)) YYABORT; }
#line 3466 "qmparse.c" /* yacc.c:1648  */
    break;

  case 172:
#line 1330 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[-1].ival) != OROP) {
				    thr->qmstat = SYNTAX_ERR;
				    YYABORT;
				  } else
				    (yyval.ival) = ORELSEOP; }
#line 3476 "qmparse.c" /* yacc.c:1648  */
    break;

  case 175:
#line 1340 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3482 "qmparse.c" /* yacc.c:1648  */
    break;

  case 176:
#line 1343 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[-1].ival) != ANDOP) {
				    thr->qmstat = SYNTAX_ERR;
				    YYABORT;
				  } else
				    (yyval.ival) = ANDTHENOP; }
#line 3492 "qmparse.c" /* yacc.c:1648  */
    break;

  case 179:
#line 1354 "qmparse.y" /* yacc.c:1648  */
    { mpz_neg((yyvsp[0].zval), (yyvsp[0].zval));
		                  if (!pushmpz(thr, (yyvsp[0].zval))) YYABORT; }
#line 3499 "qmparse.c" /* yacc.c:1648  */
    break;

  case 180:
#line 1356 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfloat(thr, -(yyvsp[0].fval))) YYABORT; }
#line 3505 "qmparse.c" /* yacc.c:1648  */
    break;

  case 181:
#line 1357 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun(UMINOP)) YYABORT; }
#line 3511 "qmparse.c" /* yacc.c:1648  */
    break;

  case 182:
#line 1358 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3517 "qmparse.c" /* yacc.c:1648  */
    break;

  case 185:
#line 1366 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3523 "qmparse.c" /* yacc.c:1648  */
    break;

  case 188:
#line 1374 "qmparse.y" /* yacc.c:1648  */
    { if (!pushbin((yyvsp[-1].ival))) YYABORT; }
#line 3529 "qmparse.c" /* yacc.c:1648  */
    break;

  case 189:
#line 1377 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = COMPOP; }
#line 3535 "qmparse.c" /* yacc.c:1648  */
    break;

  case 192:
#line 1383 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, APPOP)) YYABORT; }
#line 3541 "qmparse.c" /* yacc.c:1648  */
    break;

  case 193:
#line 1386 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = FORCEOP; }
#line 3547 "qmparse.c" /* yacc.c:1648  */
    break;

  case 195:
#line 1393 "qmparse.y" /* yacc.c:1648  */
    { if (!pushmpz(thr, (yyvsp[0].zval))) YYABORT; }
#line 3553 "qmparse.c" /* yacc.c:1648  */
    break;

  case 196:
#line 1394 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfloat(thr, (yyvsp[0].fval))) YYABORT; }
#line 3559 "qmparse.c" /* yacc.c:1648  */
    break;

  case 197:
#line 1395 "qmparse.y" /* yacc.c:1648  */
    { if (!pushstr(thr, (yyvsp[0].sval))) YYABORT; }
#line 3565 "qmparse.c" /* yacc.c:1648  */
    break;

  case 198:
#line 1396 "qmparse.y" /* yacc.c:1648  */
    { YYERROR; }
#line 3571 "qmparse.c" /* yacc.c:1648  */
    break;

  case 199:
#line 1400 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[0].ival) == NONE) { YYABORT; }
				  else if (!pushfun(thr, (yyvsp[0].ival))) YYABORT; }
#line 3578 "qmparse.c" /* yacc.c:1648  */
    break;

  case 200:
#line 1402 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, (yyvsp[-1].ival))) YYABORT; }
#line 3584 "qmparse.c" /* yacc.c:1648  */
    break;

  case 201:
#line 1406 "qmparse.y" /* yacc.c:1648  */
    { thr->qmstat = BAD_OBJ; YYABORT; }
#line 3590 "qmparse.c" /* yacc.c:1648  */
    break;

  case 202:
#line 1411 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3596 "qmparse.c" /* yacc.c:1648  */
    break;

  case 203:
#line 1416 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3602 "qmparse.c" /* yacc.c:1648  */
    break;

  case 204:
#line 1419 "qmparse.y" /* yacc.c:1648  */
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, (yyvsp[-2].ival)) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
#line 3610 "qmparse.c" /* yacc.c:1648  */
    break;

  case 205:
#line 1424 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3616 "qmparse.c" /* yacc.c:1648  */
    break;

  case 206:
#line 1427 "qmparse.y" /* yacc.c:1648  */
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, (yyvsp[-2].ival)) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
#line 3624 "qmparse.c" /* yacc.c:1648  */
    break;

  case 207:
#line 1432 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3630 "qmparse.c" /* yacc.c:1648  */
    break;

  case 208:
#line 1435 "qmparse.y" /* yacc.c:1648  */
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, (yyvsp[-2].ival)) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
#line 3638 "qmparse.c" /* yacc.c:1648  */
    break;

  case 209:
#line 1440 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3644 "qmparse.c" /* yacc.c:1648  */
    break;

  case 210:
#line 1443 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun(MINOP)) YYABORT; }
#line 3650 "qmparse.c" /* yacc.c:1648  */
    break;

  case 211:
#line 1446 "qmparse.y" /* yacc.c:1648  */
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, (yyvsp[-2].ival)) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
#line 3658 "qmparse.c" /* yacc.c:1648  */
    break;

  case 212:
#line 1451 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3664 "qmparse.c" /* yacc.c:1648  */
    break;

  case 213:
#line 1454 "qmparse.y" /* yacc.c:1648  */
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, (yyvsp[-2].ival)) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
#line 3672 "qmparse.c" /* yacc.c:1648  */
    break;

  case 214:
#line 1459 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3678 "qmparse.c" /* yacc.c:1648  */
    break;

  case 215:
#line 1462 "qmparse.y" /* yacc.c:1648  */
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, (yyvsp[-2].ival)) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
#line 3686 "qmparse.c" /* yacc.c:1648  */
    break;

  case 216:
#line 1467 "qmparse.y" /* yacc.c:1648  */
    { if (!pushun((yyvsp[-1].ival))) YYABORT; }
#line 3692 "qmparse.c" /* yacc.c:1648  */
    break;

  case 217:
#line 1470 "qmparse.y" /* yacc.c:1648  */
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, (yyvsp[-2].ival)) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
#line 3700 "qmparse.c" /* yacc.c:1648  */
    break;

  case 218:
#line 1477 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP)) YYABORT; }
#line 3706 "qmparse.c" /* yacc.c:1648  */
    break;

  case 220:
#line 1485 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushfun(thr, PAIROP)) YYABORT; }
#line 3713 "qmparse.c" /* yacc.c:1648  */
    break;

  case 221:
#line 1488 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushfun(thr, PAIROP) ||
				      !pushfun(thr, VOIDOP) ||
				      !pushfun(thr, PAIROP)) YYABORT; }
#line 3722 "qmparse.c" /* yacc.c:1648  */
    break;

  case 222:
#line 1493 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, PAIROP)) YYABORT; }
#line 3728 "qmparse.c" /* yacc.c:1648  */
    break;

  case 223:
#line 1495 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, NILOP) ||
				      !pushfun(thr, CONSOP)) YYABORT; }
#line 3735 "qmparse.c" /* yacc.c:1648  */
    break;

  case 224:
#line 1498 "qmparse.y" /* yacc.c:1648  */
    { if (((yyvsp[-1].ival))?(!pushbin(TENUMOP)):
				      (!pushun(TENUM1OP))) YYABORT; }
#line 3742 "qmparse.c" /* yacc.c:1648  */
    break;

  case 225:
#line 1501 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m)) YYABORT; }
#line 3749 "qmparse.c" /* yacc.c:1648  */
    break;

  case 226:
#line 1504 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3756 "qmparse.c" /* yacc.c:1648  */
    break;

  case 227:
#line 1507 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[-2].lval).m < 0) (yyvsp[-2].lval).m = 0;
				  if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3764 "qmparse.c" /* yacc.c:1648  */
    break;

  case 228:
#line 1511 "qmparse.y" /* yacc.c:1648  */
    { if (!pushtuple((yyvsp[-3].lval).n+1, (yyvsp[-3].lval).m)) YYABORT; }
#line 3770 "qmparse.c" /* yacc.c:1648  */
    break;

  case 229:
#line 1513 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, NILOP) ||
				      !pushlist((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m)) YYABORT; }
#line 3777 "qmparse.c" /* yacc.c:1648  */
    break;

  case 230:
#line 1516 "qmparse.y" /* yacc.c:1648  */
    { if (((yyvsp[-1].ival))?(!pushbin(TENUMOP)):
				      (!pushun(TENUM1OP))) YYABORT; }
#line 3784 "qmparse.c" /* yacc.c:1648  */
    break;

  case 231:
#line 1519 "qmparse.y" /* yacc.c:1648  */
    { static char sym[20];
				  int fno = mksym(strcpy(sym, "cond::tupleof"));
				  if (fno == NONE) {
				    thr->qmstat = SYNTAX_ERR; YYABORT;
				  } else
				    (yyval.ival) = fno; }
#line 3795 "qmparse.c" /* yacc.c:1648  */
    break;

  case 232:
#line 1526 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m) ||
				      !pushbin((yyvsp[-2].ival))) YYABORT; }
#line 3803 "qmparse.c" /* yacc.c:1648  */
    break;

  case 233:
#line 1532 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m)) YYABORT; }
#line 3810 "qmparse.c" /* yacc.c:1648  */
    break;

  case 234:
#line 1535 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3817 "qmparse.c" /* yacc.c:1648  */
    break;

  case 235:
#line 1538 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3824 "qmparse.c" /* yacc.c:1648  */
    break;

  case 236:
#line 1541 "qmparse.y" /* yacc.c:1648  */
    { if (!pushtuple((yyvsp[-3].lval).n+1, (yyvsp[-3].lval).m)) YYABORT; }
#line 3830 "qmparse.c" /* yacc.c:1648  */
    break;

  case 237:
#line 1546 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, NILOP)) YYABORT; }
#line 3836 "qmparse.c" /* yacc.c:1648  */
    break;

  case 238:
#line 1548 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, NILOP) ||
				      !pushlist((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m)) YYABORT; }
#line 3843 "qmparse.c" /* yacc.c:1648  */
    break;

  case 239:
#line 1551 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, NILOP) ||
				      !pushlist((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3850 "qmparse.c" /* yacc.c:1648  */
    break;

  case 240:
#line 1554 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[-2].lval).m < 0) (yyvsp[-2].lval).m = 0;
				  if (!pushfun(thr, NILOP) ||
				      !pushlist((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3858 "qmparse.c" /* yacc.c:1648  */
    break;

  case 241:
#line 1558 "qmparse.y" /* yacc.c:1648  */
    { if (!pushlist((yyvsp[-3].lval).n+1, (yyvsp[-3].lval).m)) YYABORT; }
#line 3864 "qmparse.c" /* yacc.c:1648  */
    break;

  case 242:
#line 1560 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, NILOP) ||
				      !pushlist((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m)) YYABORT; }
#line 3871 "qmparse.c" /* yacc.c:1648  */
    break;

  case 243:
#line 1563 "qmparse.y" /* yacc.c:1648  */
    { if (((yyvsp[-1].ival))?(!pushbin(ENUMOP)):
				      (!pushun(ENUM1OP))) YYABORT; }
#line 3878 "qmparse.c" /* yacc.c:1648  */
    break;

  case 244:
#line 1566 "qmparse.y" /* yacc.c:1648  */
    { static char sym[20];
				  int fno = mksym(strcpy(sym, "cond::listof"));
				  if (fno == NONE) {
				    thr->qmstat = SYNTAX_ERR; YYABORT;
				  } else
				    (yyval.ival) = fno; }
#line 3889 "qmparse.c" /* yacc.c:1648  */
    break;

  case 245:
#line 1573 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m) ||
				      !pushbin((yyvsp[-2].ival))) YYABORT; }
#line 3897 "qmparse.c" /* yacc.c:1648  */
    break;

  case 246:
#line 1580 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, SNILOP)) YYABORT; }
#line 3903 "qmparse.c" /* yacc.c:1648  */
    break;

  case 247:
#line 1582 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, SNILOP) ||
				      !pushstream((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m)) YYABORT; }
#line 3910 "qmparse.c" /* yacc.c:1648  */
    break;

  case 248:
#line 1585 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, SNILOP) ||
				      !pushstream((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3917 "qmparse.c" /* yacc.c:1648  */
    break;

  case 249:
#line 1588 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[-2].lval).m < 0) (yyvsp[-2].lval).m = 0;
				  if (!pushfun(thr, SNILOP) ||
				      !pushstream((yyvsp[-2].lval).n+1, (yyvsp[-2].lval).m)) YYABORT; }
#line 3925 "qmparse.c" /* yacc.c:1648  */
    break;

  case 250:
#line 1592 "qmparse.y" /* yacc.c:1648  */
    { if (!pushstream((yyvsp[-3].lval).n+1, (yyvsp[-3].lval).m)) YYABORT; }
#line 3931 "qmparse.c" /* yacc.c:1648  */
    break;

  case 251:
#line 1594 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, NILOP) ||
				      !pushlist((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m)) YYABORT; }
#line 3938 "qmparse.c" /* yacc.c:1648  */
    break;

  case 252:
#line 1597 "qmparse.y" /* yacc.c:1648  */
    { if (((yyvsp[-1].ival))?(!pushbin(SENUMOP)):
				      (!pushun(SENUM1OP))) YYABORT; }
#line 3945 "qmparse.c" /* yacc.c:1648  */
    break;

  case 253:
#line 1600 "qmparse.y" /* yacc.c:1648  */
    { static char sym[20];
				  int fno = mksym(strcpy(sym, "cond::streamof"));
				  if (fno == NONE) {
				    thr->qmstat = SYNTAX_ERR; YYABORT;
				  } else
				    (yyval.ival) = fno; }
#line 3956 "qmparse.c" /* yacc.c:1648  */
    break;

  case 254:
#line 1607 "qmparse.y" /* yacc.c:1648  */
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple((yyvsp[-1].lval).n+1, (yyvsp[-1].lval).m) ||
				      !pushbin((yyvsp[-2].ival))) YYABORT; }
#line 3964 "qmparse.c" /* yacc.c:1648  */
    break;

  case 255:
#line 1613 "qmparse.y" /* yacc.c:1648  */
    { YYABORT; }
#line 3970 "qmparse.c" /* yacc.c:1648  */
    break;

  case 256:
#line 1617 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = 0; }
#line 3976 "qmparse.c" /* yacc.c:1648  */
    break;

  case 257:
#line 1618 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = 1; }
#line 3982 "qmparse.c" /* yacc.c:1648  */
    break;

  case 258:
#line 1625 "qmparse.y" /* yacc.c:1648  */
    { (yyval.lval).n = 2; (yyval.lval).m = -1; }
#line 3988 "qmparse.c" /* yacc.c:1648  */
    break;

  case 259:
#line 1627 "qmparse.y" /* yacc.c:1648  */
    { (yyval.lval).n = (yyvsp[-2].lval).n+1; (yyval.lval).m = (yyvsp[-2].lval).m; }
#line 3994 "qmparse.c" /* yacc.c:1648  */
    break;

  case 260:
#line 1629 "qmparse.y" /* yacc.c:1648  */
    { (yyvsp[-2].lval).n++; if (!pushgroup(&(yyvsp[-2].lval).n, &(yyvsp[-2].lval).m)) YYABORT;
				  (yyval.lval).n = (yyvsp[-2].lval).n; (yyval.lval).m = (yyvsp[-2].lval).m; }
#line 4001 "qmparse.c" /* yacc.c:1648  */
    break;

  case 261:
#line 1634 "qmparse.y" /* yacc.c:1648  */
    { if (!swap() ||
				      !pushfun(thr, VOIDOP) ||
				      !pushfun(thr, PAIROP) ||
				      !swap()) YYABORT;
				  (yyval.lval).n = 2; (yyval.lval).m = 1; }
#line 4011 "qmparse.c" /* yacc.c:1648  */
    break;

  case 262:
#line 1640 "qmparse.y" /* yacc.c:1648  */
    { (yyval.lval).n = (yyvsp[-2].lval).n+1; (yyval.lval).m = (yyvsp[-2].lval).m; }
#line 4017 "qmparse.c" /* yacc.c:1648  */
    break;

  case 263:
#line 1642 "qmparse.y" /* yacc.c:1648  */
    { (yyvsp[-2].lval).n++; if (!pushgroup(&(yyvsp[-2].lval).n, &(yyvsp[-2].lval).m)) YYABORT;
				  (yyval.lval).n = (yyvsp[-2].lval).n; (yyval.lval).m = (yyvsp[-2].lval).m; }
#line 4024 "qmparse.c" /* yacc.c:1648  */
    break;

  case 264:
#line 1647 "qmparse.y" /* yacc.c:1648  */
    { (yyval.lval).n = 1; (yyval.lval).m = -1; }
#line 4030 "qmparse.c" /* yacc.c:1648  */
    break;

  case 265:
#line 1649 "qmparse.y" /* yacc.c:1648  */
    { (yyval.lval).n = (yyvsp[-2].lval).n+1; (yyval.lval).m = (yyvsp[-2].lval).m; }
#line 4036 "qmparse.c" /* yacc.c:1648  */
    break;

  case 266:
#line 1651 "qmparse.y" /* yacc.c:1648  */
    { (yyvsp[-2].lval).n++; if (!pushgroup(&(yyvsp[-2].lval).n, &(yyvsp[-2].lval).m)) YYABORT;
				  (yyval.lval).n = (yyvsp[-2].lval).n; (yyval.lval).m = (yyvsp[-2].lval).m; }
#line 4043 "qmparse.c" /* yacc.c:1648  */
    break;

  case 267:
#line 1655 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = EQOP; }
#line 4049 "qmparse.c" /* yacc.c:1648  */
    break;

  case 268:
#line 1656 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = IDOP; }
#line 4055 "qmparse.c" /* yacc.c:1648  */
    break;

  case 269:
#line 1657 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = MINOP; }
#line 4061 "qmparse.c" /* yacc.c:1648  */
    break;

  case 270:
#line 1658 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[-1].ival) != OROP) {
				    thr->qmstat = SYNTAX_ERR;
				    YYABORT;
				  } else
				    (yyval.ival) = ORELSEOP; }
#line 4071 "qmparse.c" /* yacc.c:1648  */
    break;

  case 271:
#line 1663 "qmparse.y" /* yacc.c:1648  */
    { if ((yyvsp[-1].ival) != ANDOP) {
				    thr->qmstat = SYNTAX_ERR;
				    YYABORT;
				  } else
				    (yyval.ival) = ANDTHENOP; }
#line 4081 "qmparse.c" /* yacc.c:1648  */
    break;

  case 272:
#line 1668 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = FORCEOP; }
#line 4087 "qmparse.c" /* yacc.c:1648  */
    break;

  case 273:
#line 1669 "qmparse.y" /* yacc.c:1648  */
    { (yyval.ival) = COMPOP; }
#line 4093 "qmparse.c" /* yacc.c:1648  */
    break;


#line 4097 "qmparse.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1681 "qmparse.y" /* yacc.c:1907  */


yyerror(s)
	char           *s;
{
  if (thr->qmstat == OK && (thr > thr0 || !checkbrk) &&
      (strcmp(s, "parse error") == 0 || strcmp(s, "syntax error") == 0))
    thr->qmstat = SYNTAX_ERR;
}

/* unicode helpers */

#ifdef HAVE_UNICODE

static inline long
u8decodes(char *s, char **t)
{
  size_t n = 0;
  unsigned p = 0, q = 0;
  unsigned long c = 0;
  if (s[0] == 0)
    return -1;
  else if (s[1] == 0) {
    *t = s+1;
    return (unsigned char)s[0];
  }
  for (; n == 0 && *s; s++) {
    unsigned char uc = (unsigned char)*s;
    if (q == 0) {
      if (((signed char)uc) < 0) {
	switch (uc & 0xf0) {
	case 0xc0: case 0xd0:
	  q = 1;
	  c = uc & 0x1f;
	  break;
	case 0xe0:
	  q = 2;
	  c = uc & 0xf;
	  break;
	case 0xf0:
	  if ((uc & 0x8) == 0) {
	    q = 3;
	    c = uc & 0x7;
	  } else
	    c = uc;
	  break;
	default:
	  c = uc;
	  break;
	}
      } else
	c = uc;
      p = 0; if (q == 0) n++;
    } else if ((uc & 0xc0) == 0x80) {
      /* continuation byte */
      c = c << 6 | (uc & 0x3f);
      if (--q == 0)
	n++;
      else
	p++;
    } else {
      /* malformed char */
      return -1;
    }
  }
  if (n == 1) {
    *t = s;
    return c;
  } else
    return -1;
}

static inline char *
u8encode(char *t, unsigned long c)
{
  unsigned char *uc = (unsigned char*)t;
  if (c < 0x80) {
    uc[1] = 0;
    uc[0] = c;
  } else if (c < 0x800) {
    uc[2] = 0;
    uc[1] = 0x80 | c&0x3f;
    c = c >> 6;
    uc[0] = 0xc0 | c;
  } else if (c < 0x10000) {
    uc[3] = 0;
    uc[2] = 0x80 | c&0x3f;
    c = c >> 6;
    uc[1] = 0x80 | c&0x3f;
    c = c >> 6;
    uc[0] = 0xe0 | c;
  } else {
    uc[4] = 0;
    uc[3] = 0x80 | c&0x3f;
    c = c >> 6;
    uc[2] = 0x80 | c&0x3f;
    c = c >> 6;
    uc[1] = 0x80 | c&0x3f;
    c = c >> 6;
    uc[0] = 0xf0 | c;
  }
  return t;
}

#ifdef HAVE_ICONV

#define CHUNKSZ 128

static inline char *
icfromutf8(iconv_t ic[2], char *s)
{
  if (ic[1] == (iconv_t)-2) {
    char *codeset = default_encoding();
    if (codeset && strcmp(codeset, "UTF-8"))
      ic[1] = iconv_open(codeset, "UTF-8");
    else
      ic[1] = (iconv_t)-1;
  }
  if (ic[1] == (iconv_t)-1)
    return NULL;
  else {
    /* Here the input buffer may be NULL, to emit a terminating shift
       sequence. In this case we initialize an output buffer of size
       CHUNKSZ. */
    size_t l = s?strlen(s):0, m = s?l:CHUNKSZ;
    char *t = malloc(m+1), *t1;
    char *inbuf = s, *outbuf = t;
    size_t inbytes = l, outbytes = m;

    while (iconv(ic[1], &inbuf, &inbytes, &outbuf, &outbytes) ==
	   (size_t)-1)
      if (errno == E2BIG) {
	/* try to enlarge the output buffer */
	size_t k = outbuf-t;
	if ((t1 = realloc(t, m+CHUNKSZ+1))) {
	  t = t1;
	  outbuf = t+k;
	  m += CHUNKSZ;
	  outbytes += CHUNKSZ;
	} else {
	  /* memory overflow */
	  free(t);
	  return NULL;
	}
      } else {
	/* conversion error */
	free(t);
	return NULL;
      }
    /* terminate the output string */
    *outbuf = 0;
    if (!(t1 = realloc(t, strlen(t)+1)))
      /* this shouldn't happen */
      return t;
    else
      return t1;
  }
}

/* conversion between UTF-8 and wchar_t */

static iconv_t myic[2] = { (iconv_t)-1, (iconv_t)-1 };

static inline wchar_t *
ictowcs(wchar_t *t, char *s)
{
  if (myic[1] == (iconv_t)-1)
    myic[1] = iconv_open("WCHAR_T", "UTF-8");
  if (myic[1] == (iconv_t)-1)
    return NULL;
  else {
    size_t l = strlen(s);
    char *inbuf = s; wchar_t *outbuf = t;
    size_t inbytes = l, outbytes = l*sizeof(wchar_t);

    if (iconv(myic[1], &inbuf, &inbytes, (char**)&outbuf, &outbytes) ==
	(size_t)-1)
      return NULL;
    /* terminate the output string */
    *outbuf = 0;
    return t;
  }
}

#endif

#ifdef __STDC_ISO_10646__
#define MY_ISO_10646
#else
#ifndef HAVE_ICONV
#warning "wchar_t encoding unknown and iconv not available, assuming ISO 10646"
#define MY_ISO_10646
#endif
#endif

#ifdef MY_ISO_10646
#define towchar(c) ((wchar_t)(c))
#else
static wchar_t towchar(unsigned long c)
{
  char s[5]; /* single utf-8 char can have at most 4 bytes, plus terminal 0 */
  wchar_t t[5]; /* just to be safe; 2 should actually be enough */
  u8encode(s, c);
  if (ictowcs(t, s))
    return t[0];
  else
    /* Your system is so utterly broken that we can't even convert UTF-8 to
       wchar_t. You should probably configure with --without-unicode. But
       let's just pretend we have an ISO 10646 compatible encoding anyway. */
    return (wchar_t)c;
}
#endif

#endif

/* routines to construct expressions: */

static swap()
	/* swap the topmost two stack elements */
{
  EXPR		*x;

  x = thr->xsp[-2]; thr->xsp[-2] = thr->xsp[-1]; thr->xsp[-1] = x;
  return (1);
}

static rot()
	/* rotate the topmost three stack elements */
{
  EXPR		*x;

  x = thr->xsp[-3]; thr->xsp[-3] = thr->xsp[-2];
  thr->xsp[-2] = thr->xsp[-1]; thr->xsp[-1] = x;
  return (1);
}

static pushtern(fno)
     /* process ternary op */
     int		fno;
{
  return (rot() && pushfun(thr, fno) && swap() && pushfun(thr, APPOP) &&
	  rot() && pushfun(thr, APPOP) && swap() && pushfun(thr, APPOP));
}

static pushbin(fno)
     /* process binary op */
     int		fno;
{
  return (swap() && pushfun(thr, fno) && swap() && pushfun(thr, APPOP) &&
	  swap() && pushfun(thr, APPOP));
}

static pushun(fno)
	/* process unary op */
     int		fno;
{
  return (pushfun(thr, fno) && swap() && pushfun(thr, APPOP));
}

static pushlist(int n, int m)
/* process list elements */
{
  if (m >= 0 && !pushgroup(&n, &m)) return 0;
  while (--n > 0)
    if (!pushfun(thr, CONSOP)) return 0;
  return 1;
}

static pushstream(int n, int m)
/* process stream elements */
{
  if (m >= 0 && !pushgroup(&n, &m)) return 0;
  while (--n > 0)
    if (!pushbin(SCONSOP)) return 0;
  return 1;
}

static pushtuple(int n, int m)
/* process tuple elements */
{
  if (m >= 0 && !pushgroup(&n, &m)) return 0;
  while (--n > 0)
    if (!pushfun(thr, PAIROP)) return 0;
  return 1;
}

static pushgroup(int *n, int *m)
/* process element group */
{
  int k, res;
  EXPR *x;
  if (*m < 0) *m = 0;
  k = *n-*m;
  x = *--thr->xsp;
  res = pushfun(thr, VOIDOP) && pushtuple(k, -1);
  if (thr->xsp) *(thr->xsp++) = x;
  *n -= k-2; *m = *n-1;
  return res;
}

/* eval stats */

static init_stats()
{
  thr0->stats_init = 1;
  thr0->stats_fini = 0;
  thr0->nredns = thr0->nexprs = thr0->maxexprs = 0;
  thr0->starttime = clock();
  return 1;
}

static fini_stats()
{
  thr0->endtime = clock();
  thr0->stats_fini = 1;
  return 1;
}

static print_stats(all)
     int all;
{
  THREAD *thr;
  for (thr = thr0; thr < thr0+(all?nthreads:1); thr++)
    if (thr->used && (thr == thr0 || !thr->active) && thr->stats_init) {
      if (!thr->stats_fini ||
	  thr->starttime == (clock_t)-1 ||
	  thr->endtime == (clock_t)-1)
	if (all || thr > thr0)
	  printf("thread #%d: %lu reduction%s, %lu cell%s\n",
		 thr-thr0,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
	else
	  printf("%lu reduction%s, %lu cell%s\n",
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
      else
	if (all || thr > thr0)
	  printf("thread #%d: %0.3g secs, %lu reduction%s, %lu cell%s\n",
		 thr-thr0,
		 ((double)(thr->endtime-thr->starttime))/(double)CLOCKS_PER_SEC,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
	else
	  printf("%0.3g secs, %lu reduction%s, %lu cell%s\n",
		 ((double)(thr->endtime-thr->starttime))/(double)CLOCKS_PER_SEC,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
  }
}

/* parse actions: */

#if defined(HAVE_UNICODE) && !defined(HAVE_WCWIDTH)
static inline wcwidth(wchar_t c)
{
  if (iswprint(c))
    return 1;
  else
    return -1;
}
#endif

static int tokoffs = 0;

static error_report(base, p, tok)
     char *base, *p, *tok;
{
  char *q = p, *r = strchr(p, '\n'), *s, *t, c;
  int l = strlen(tok), i, xw = 0;
  while (q > base && q[-1] != '\n') --q;
  if (r) c = *r, *r = 0;
  if (tok && *tok && p-q >= l)
    if (strncmp(p-l, tok, l) == 0)
      p -= l;
    else if (p-q >= l+1 && strncmp(p-l-1, tok, l) == 0)
      /* token may actually be off one to the left because of lookahead */
      p -= l+1;
    else
      /* token not found; assume it's the character to the left of the current
	 position */
      --p;
  if (tok && strcmp(tok, "\"") == 0 && *p == '"') {
    /* it's a string token, try to back up to the beginning of the string */
    while (p > q && (p[-1] != '"' || p > q+1 && p[-2] == '\\')) --p;
    if (p > q && p[-1] == '"') p = p+tokoffs-1;
  }
  if (p < q) p = q;
  s = malloc(p-q+2);
  if (!s) fatal("memory overflow");
  strncpy(s, q, p-q+1);
  s[p-q+1] = s[p-q] = 0;
#ifdef HAVE_UNICODE
  {
    /* Try to guestimate the actual width of the output string. */
    char *s1 = s, *t1, *s2 = malloc(p-q+2), *t2 = s2;
    if (!s2) fatal("memory overflow");
    while (*s1) {
      long c = u8decodes(s1, &t1);
      if (c < 0)
	/* No legal UTF-8, bail out. */
	break;
      else {
	int wd = wcwidth(towchar(c));
	if (c < 128 && isspace(c))
	  *t2++ = c;
	else if (wd >= 1) {
	  *t2++ = ' ';
	  xw += wd-1;
	}
	s1 = t1;
      }
    }
    *t2++ = '^';
    *t2++ = 0;
    free(s); s = s2;
  }
#else
  for (t = s; *t; t++)
    if (!isspace(*t))
      *t = ' ';
  s[p-q] = '^';
#endif
  printf(">>> %s\n", utf8_to_sys(q));
  for (i = 0; i < xw; i++) putc(' ', stdout);
  printf("    %s\n", s);
  if (r) *r = c;
  free(s);
}

DECLARE_YYTEXT

static char *tok = NULL, *p = NULL;;
static int toksz = 0;

extern char *my_yytext;

static savepos()
{
  THREAD *thr = get_thr();
  char *text = (*yytext||!my_yytext)?yytext:my_yytext;
  int l = strlen(text);
  p = actchar();
  if (thr->qmstat == BAD_ESC && actbuf())
    tokoffs = strlen(actbuf())+1;
  else
    tokoffs = 0;
  if (l < 1000) l = 1000;
  if (!tok)
    tok = malloc((toksz = l+1)*sizeof(char));
  else if (toksz < l+1)
    tok = realloc(tok, (toksz = l+1)*sizeof(char));
  if (!tok)
    fatal("memory overflow");
  strcpy(tok, text);
}

extern int actlineno;

static clean()
{
  THREAD *thr = get_thr();
  int res = !(thr->qmstat != OK && thr->qmstat != HALT && thr->qmstat != QUIT);
  if (ferror(stdin))
    clearerr(stdin);
  flush_shift();
  if (!res) {
    if (pmode == SOURCE) {
      char msg[MAXSTRLEN];
      sprintf(msg, "File %s, line %d: %s", psource, actlineno,
	      qmmsg[thr->qmstat]);
      error(msg);
    } else
      error(qmmsg[thr->qmstat]);
    if (thr->qmstat == XCEPT && thr->xsp > thr->xst) {
      printx(thr->xsp[-1]); flush_shift(); printf("\n");
    }
    if ((pmode == INTERACT || pmode == SOURCE) && base && p)
      error_report(base, p, tok);
  }
  if (!quitflag && thr->qmstat != QUIT)
    clear(0);
  thr->debug = debug;
  thr->mode = 1;
  return res && !checkbrk;
}

static expression()
{
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (!checkbrk && init_stats() && eval(thr, thr->xsp[-1]) && fini_stats() &&
      !checkbrk) {
    flush_shift();
    printx(thr->xsp[-1]);
    flush_shift();
    putchar('\n');
    if (thr->xsp[-1]->fno != DEFVAROP)
      setvar(DEFVAROP, thr->xsp[-1]);
  } else if (!checkbrk)
    fini_stats();
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  savepos();
  return clean();
}

static assignment()
{
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (!checkbrk && init_stats() && eval(thr, thr->xsp[-1])) {
    thr->nredns++;
    thr->args[0] = thr->xsp[-3];
    thr->args[1] = thr->xsp[-1];
    (*funtb[DEFOP])(thr);
    fini_stats();
  }
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  savepos();
  return clean();
}

static unassignment(int id)
{
  if (symtb[id].x)
    setvar(id, NULL);
  savepos();
  return clean();
}

static int declid = NONE;
static vardecl(int id)
{
  if (id != NONE) {
    if (id >= symtbsz)
      symtb[id].flags |= (VSYM|DCL);
    else if (symtb[id].modno == mainno) {
      if (!(symtb[id].flags&VSYM)) {
	thr->qmstat = BAD_DEF;
	id = NONE;
      }
    } else {
      symtb[id].flags &= ~VIS;
      id = newsym(strsp+symtb[id].pname);
      if (id != NONE) symtb[id].flags |= (VSYM|DCL);
    }
  }
  declid = id;
  savepos();
  return clean();
}

static initializer()
{
  if (declid != NONE) {
#ifdef USE_THREADS
    pthread_mutex_unlock(&parse_mutex);
#endif
    if (!checkbrk && init_stats() && eval(thr, thr->xsp[-1])) {
      setvar(declid, thr->xsp[-1]);
      fini_stats();
    }
#ifdef USE_THREADS
    pthread_mutex_lock(&parse_mutex);
#endif
  }
  savepos();
  return clean();
}

/* built-in commands: */

static printstr(s)
     char *s;
{
  printf("%s\n", s);
}

static strparam(a, s)
     char *a, **s;
{
  *s = NULL;
  if (!checkbrk && !(*s = utf8_to_sys_dup(a)))
    thr->qmstat = MEM_OVF;
  savepos();
  if (clean())
    return *s != NULL;
  else {
    if (*s) free(*s);
    *s = NULL;
    return 0;
  }
}

static intparam(a, i)
     char *a; long *i;
{
  int res = !checkbrk;
  if (res) {
    char *s = a;
    while (isdigit(*s)) s++;
    if (!*s) {
      res = 1;
      *i = atol(a);
    } else
      thr->qmstat = SYNTAX_ERR;
  }
  savepos();
  return clean() && res;
}

static boolparam(a, b)
     char *a; int *b;
{
  int res = !checkbrk;
  if (res)
    if (!strcmp(a, "on"))
      *b = 1;
    else if (!strcmp(a, "off"))
      *b = 0;
    else {
      res = 0;
      thr->qmstat = SYNTAX_ERR;
    }
  savepos();
  return clean() && res;
}

static boolstrparam(a, b, s)
     char *a; int *b; char **s;
{
  int res = !checkbrk;
  *s = NULL;
  if (res)
    if (!strcmp(a, "on"))
      *b = 1;
    else if (!strcmp(a, "off"))
      *b = 0;
    else
      return strparam(a, s);
  savepos();
  return clean() && res;
}

static allparam(a)
     char *a;
{
  int res = !checkbrk;
  if (res)
    if (strcmp(a, "all")) {
      res = 0;
      thr->qmstat = SYNTAX_ERR;
    }
  savepos();
  return clean() && res;
}

static copyright()
{
  if (!checkbrk) {
    printf("\n");
    printf(signon, version, sysinfo, year);
    printf("%s", copying);
  }
  savepos();
  return clean();
}

static shell()
{
  if (!checkbrk) {
    char shell_command[MAXSTRLEN];
    getln(shell_command);
    push_sigint(SIG_DFL);
    system(shell_command);
    pop_sigint();
  }
  savepos();
  return clean();
}

#ifdef USE_READLINE
extern int use_readline;
#else
static histwarn()
{
  static done = 0;
  if (done)
    return;
  else if (gflag || !iflag || !isatty(fileno(stdin)))
    done = 1;
  else {
    error("Warning: history not supported");
    done = 1;
  }
}
#endif

static sethistfile(s)
     char *s;
{
#ifdef USE_READLINE
  if (!gflag && use_readline && histmax > 0) {
    char h[MAXSTRLEN];
    write_history(expand(h, histfile));
  }
#else
  histwarn();
#endif
  if (histfile) free(histfile);
  histfile = s;
#ifdef USE_READLINE
  if (!gflag && use_readline) {
    char h[MAXSTRLEN];
    clear_history();
    if (histmax > 0)
      read_history(expand(h, histfile));
    stifle_history(histmax);
  }
#endif
}

static sethistsize(i)
     int i;
{
  histmax = i>=0?i:0;
#ifdef USE_READLINE
  if (!gflag && use_readline)
    stifle_history(histmax);
#else
  histwarn();
#endif
}

static help(s)
     char *s;
{
  static char *info = NULL;
  char *cmd;
  if (!info && !(info = getenv("INFO_PROGRAM")))
    info = "info";
  if ((cmd = malloc(((s?strlen(s):0)*4+3+
		     strlen(info)+MAXSTRLEN)*sizeof(char)))) {
    if (s) {
      char *buf = malloc(4*strlen(s)+1);
      if (buf) {
	sprintf(cmd, "%s -f qdoc --index-search \"%s\"", info, pstr(buf, s));
	free(buf);
      } else {
	free(cmd);
	thr->qmstat = MEM_OVF;
	return clean();
      }
    } else
      sprintf(cmd, "%s -f qdoc", info);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  } else
    thr->qmstat = MEM_OVF;
  return clean();
}

static edit(s)
     char *s;
{
  static char *editor = NULL;
  char *cmd;
  if (!editor && !(editor = getenv("EDITOR")))
    editor = "vi";
  if ((cmd = malloc((4*strlen(s)+strlen(editor)+10)*sizeof(char)))) {
    if (s && *s) {
      char *buf = malloc(4*strlen(s)+1);
      if (buf) {
	sprintf(cmd, "%s \"%s\"", editor, pstr(buf, s));
	free(buf);
      } else {
	free(cmd);
	thr->qmstat = MEM_OVF;
	return clean();
      }
    } else
      strcpy(cmd, editor);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  } else
    thr->qmstat = MEM_OVF;
  return clean();
}

static save_vars(s)
     char *s;
{
  FILE	       *fp;
  int		res = 0, i;
  char         *s_bak = save_file;

  if (!s) {
    if (!save_file) save_file = strdup(".q_vars");
    if (!save_file) {
      error(qmmsg[MEM_OVF]);
      return 0;
    }
    s = save_file;
  } else
    save_file = s;
  if ((fp = fopen(s, "w"))) {
#if defined(HAVE_UNICODE) && defined(HAVE_ICONV)
    iconv_t ic[2] = { (iconv_t)-2, (iconv_t)-2 };
#endif
    /* store variable definitions: */
    for (i = symtbsz; i<symtbsz+tmptbsz; i++)
      if (symtb[i].x && i != DEFVAROP) {
	char str[MAXSTRLEN];
	fprintf(fp, "var %s = ", utf8_to_sys(pname(str, i)));
#if defined(HAVE_UNICODE) && defined(HAVE_ICONV)
	fprintx(fp, ic, symtb[i].x);
	/* flush out pending shift state */
	if (ic[1] != (iconv_t)-2 &&
	    ic[1] != (iconv_t)-1) {
	  char *s = icfromutf8(ic, NULL), *t = s;
	  if (t) {
	    while (*s) putc(*s++, fp);
	    free(t);
	  }
	}
#else
	fprintx(fp, symtb[i].x);
#endif
	fprintf(fp, ";\n");
      }
    res = !ferror(fp);
#if defined(HAVE_UNICODE) && defined(HAVE_ICONV)
    if (ic[1] != (iconv_t)-2 &&
	ic[1] != (iconv_t)-1)
      iconv_close(ic[1]);
#endif
    fclose(fp);
  }
  if (!res) {
    char msg[MAXSTRLEN];
    sprintf(msg, qmmsg[FILE_ERR], s);
    error(msg);
    if (save_file && s_bak != save_file) free(save_file);
    save_file = s_bak;
  } else if (s_bak && s_bak != save_file)
    free(s_bak);
  return res;
}

static clear_vars()
{
  int		i;

  for (i = symtbsz; i<symtbsz+tmptbsz; i++)
    if (symtb[i].x)
      setvar(i, NULL);
  clear(0);
}

int aximpsz = 0, ximpsz = 0;
char **ximp = NULL;

static
search_import(m)
     char *m;
{
  int i;
  char modname[MAXSTRLEN];
  for (i = 0; i < ximpsz; i++) {
    basename(modname, ximp[i], '.');
    if (!strcmp(modname, m))
      return i;
  }
  return NONE;
}

static
add_import(s)
     char *s;
{
  int mno;
  char modname[MAXSTRLEN], fname[MAXSTRLEN], fname2[MAXSTRLEN],
    aname[MAXSTRLEN];
  if (!s) return 0;
  basename(modname, sys_to_utf8(s), '.');
  if ((mno = getmodno(modname)) != NONE && 
      (mno == 0 || mno == mainno || globs[mno])) {
    printf("module %s already imported\n", utf8_to_sys(modname));
    free(s);
    return 0;
  }
  if (search_import(modname) != NONE) {
    printf("module %s already imported\n", utf8_to_sys(modname));
    free(s);
    return 0;
  }
  absname(aname, searchlib(fname, s));
  if (!chkfile(aname)) {
    strcat(strcpy(fname2, s), ".q");
    absname(aname, searchlib(fname, fname2));
  }
  if (!chkfile(aname)) {
    printf("file %s not found\n", s);
    free(s);
    return 0;
  }
  if (ximpsz >= aximpsz) {
    char **ximp1;
    if (!(ximp1 = arealloc(ximp, aximpsz, 10, sizeof(char*)))) {
      printf("error processing %s -- out of memory\n", s);
      free(s);
      return 0;
    } else {
      ximp = ximp1;
      aximpsz += 10;
    }
  }
  ximp[ximpsz++] = s;
  return 1;
}

extern char *source;

static
del_import(s)
     char *s;
{
  char modname[MAXSTRLEN], fname[MAXSTRLEN], fname2[MAXSTRLEN],
    aname[MAXSTRLEN];
  int i, mno, pos;
  if (!s) return 0;
  basename(modname, sys_to_utf8(s), '.');
  absname(aname, searchlib(fname, s));
  if (!chkfile(aname)) {
    strcat(strcpy(fname2, s), ".q");
    absname(aname, searchlib(fname, fname2));
  }
  pos = search_import(modname);
  mno = getmodno(modname);
  if (mno != NONE && mno != mainno && mno != 0 && !globs[mno])
    mno = NONE;
  if (mno != NONE && strcmp(aname, strsp+fnametb[mno])) {
    printf("module %s not imported\n", utf8_to_sys(modname));
    return 0;
  }
  if (mno == NONE || pos == NONE && mno != mainno) {
    if (mno != NONE)
      printf("module %s cannot be unloaded\n", utf8_to_sys(modname));
    else
      printf("module %s not imported\n", utf8_to_sys(modname));
    return 0;
  }
  if (mno == mainno) {
    if (source) free(source);
    source = NULL;
  }
  if (pos != NONE) {
    free(ximp[pos]);
    for (i = pos+1; i < ximpsz; i++)
      ximp[i-1] = ximp[i];
    ximpsz--;
  }
  return 1;
}

static
clear_imports()
{
  if (ximpsz) {
    int i;
    for (i = 0; i < ximpsz; i++)
      free(ximp[i]);
    ximpsz = 0;
    return 1;
  } else
    return 0;
}

static
modcmp(v1, v2)
	int	       *v1, *v2;
{
	return strcmp(strsp + modtb[*v1], strsp + modtb[*v2]);
}

static
print_modlist()
{
  int i, n, *v, *v0;
  if (modtbsz <= 0)
    return;
  else if (!(v = (int *)calloc(modtbsz, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (i = 0; i < modtbsz; i++) v[i] = i;
  qsort(v, modtbsz, sizeof(int), (int(*)())modcmp);
  v0 = v; n = modtbsz;
  if (!strsp[modtb[*v]]) {
    v++; n--;
  }
  if (iflag) {
    for (i = 0; i < n; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      if (dll_name[v[i]]) {
	char modn[MAXSTRLEN];
	strcat(strcpy(modn, strsp+modtb[v[i]]), "*");
	printf("%-15s", utf8_to_sys(modn));
      } else
	printf("%-15s", utf8_to_sys(strsp+modtb[v[i]]));
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s%s\n", utf8_to_sys(strsp+modtb[v[i]]),
	     dll_name[v[i]]?"*":" ");
  }
  free(v0);
}

static modules()
{
  if (!checkbrk) {
    print_modlist();
  }
  savepos();
  return clean();
}

static
print_implist()
{
  int i, n = 0, *v;
  for (i = 0; i < modtbsz; i++) 
    if (strsp[modtb[i]])
      if (i == 0 || i == mainno || globs[i])
	n++;
  if (n <= 0)
    return;
  else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  n = 0;
  for (i = 0; i < modtbsz; i++) 
    if (strsp[modtb[i]])
      if (i == 0 || i == mainno || globs[i])
	v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())modcmp);
  if (iflag) {
    for (i = 0; i < n; i++) {
      char modn[MAXSTRLEN];
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      sprintf(modn, "%s%s%s",
	      (v[i] == mainno||search_import(strsp+modtb[v[i]])!=NONE)?"+":"",
	      strsp+modtb[v[i]], dll_name[v[i]]?"*":" ");
      printf("%-15s", utf8_to_sys(modn));
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s%s%s\n",
	     (v[i] == mainno||search_import(strsp+modtb[v[i]])!=NONE)?"+":"",
	     utf8_to_sys(strsp+modtb[v[i]]), dll_name[v[i]]?"*":" ");
  }
  free(v);
}

static import_list()
{
  if (!checkbrk) {
    print_implist();
  }
  savepos();
  return clean();
}

static
idcmp(v1, v2)
     int	       *v1, *v2;
{
  int cmp = strcmp(strsp + symtb[*v1].pname, strsp + symtb[*v2].pname);
  if (cmp)
    return cmp;
  else
    return strcmp(strsp + modtb[symtb[*v1].modno],
		  strsp + modtb[symtb[*v2].modno]);
}

static
print_varlist(int all)
{
  int	       *v, n, i, sz = all?BINARY:symtbsz;
  char		s[MAXSTRLEN];
  for (n = 0, i = sz; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (i < symtbsz || (symtb[i].flags&DCL) || symtb[i].x) &&
	(symtb[i].flags&VSYM))
      n++;
  if (n == 0) {
    /* 		printf("*** no defined symbols ***\n"); */
    return;
  } else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (n = 0, i = sz; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (i < symtbsz || (symtb[i].flags&DCL) || symtb[i].x) &&
	(symtb[i].flags&VSYM))
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())idcmp);
  if (iflag) {
    for (i = 0; i < n; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      printf("%-15s", utf8_to_sys(pname(s, v[i])));
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s\n", utf8_to_sys(pname(s, v[i])));
  }
  free(v);
}

print_breakpoints()
{
  int	       *v, n, i;
  char		s[MAXSTRLEN];
  printf("break is %s", brkdbg?"on":"off");
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&(BRK|TBRK)))
      n++;
  if (n == 0) {
    /* 		printf(", no breakpoints\n"); */
    printf("\n");
    return;
  } else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&(BRK|TBRK)))
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())idcmp);
  printf(", %d breakpoint%s\n", n, (n>1)?"s":"");
  if (iflag) {
    for (i = 0; i < n; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      pname(s, v[i]);
      if (symtb[v[i]].flags & TBRK)
	strcat(s, "*");
      printf("%-15s", utf8_to_sys(s));
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s\n", utf8_to_sys(pname(s, v[i])));
  }
  free(v);
}

static breakpoints()
{
  if (!checkbrk) print_breakpoints();
  savepos();
  return clean();
}

static
profcmp(v1, v2)
     int	       *v1, *v2;
{
  int cmp = symtb[*v2].nredns - symtb[*v1].nredns;
  if (cmp)
    return cmp;
  else {
    cmp = strcmp(strsp + symtb[*v1].pname, strsp + symtb[*v2].pname);
    if (cmp)
      return cmp;
    else
      return strcmp(strsp + modtb[symtb[*v1].modno],
		    strsp + modtb[symtb[*v2].modno]);
  }
}

print_profile()
{
  int	       *v, n, i;
  char		s[MAXSTRLEN];
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&PROF))
      n++;
  if (n == 0)
    return;
  else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&PROF))
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())profcmp);
  for (i = 0; i < n; i++) {
    printf("%8d\t%s\n", symtb[v[i]].nredns,
	   utf8_to_sys(pname(s, v[i])));
    symtb[v[i]].nredns = 0;
  }
  free(v);
}

static profile()
{
  if (!checkbrk) print_profile();
  savepos();
  return clean();
}

static who(int all)
{
  if (!checkbrk) print_varlist(all);
  savepos();
  return clean();
}

static whos(int sym)
{
  if (sym >= BINARY) {
    int mno = symtb[sym].modno,
      lineno = symtb[sym].lineno,
      flags = symtb[sym].flags,
      argc = symtb[sym].argc,
      type = symtb[sym].type,
      prec = symtb[sym].prec;
    unsigned long argv = symtb[sym].argv;
    EXPR *x = (EXPR*)symtb[sym].x;
    char s[MAXSTRLEN], ts[MAXSTRLEN];
    
    pname(s, sym);
    if (type) pname(ts, type);
    if (mno == NONE || sym < BUILTIN || sym >= symtbsz || !(flags & DCL)) {
      if ((flags & VSYM) && !x && !(flags & DCL) ||
	  !(flags & VSYM) && !(flags & DCL))
	printf("%-15s\tnot a defined symbol", utf8_to_sys(s));
      else
	printf("%-15s\t%s %s%s%s%s symbol", utf8_to_sys(s),
	       (sym<BUILTIN)?"builtin":"user-defined",
	       argv?"special ":"",
	       (flags&CST)?"const ":"",
	       (flags&VIRT)?"virtual ":"",
	       (flags&VSYM)?"variable":"function");
      if ((flags&EXT) && symtb[sym].xfno!=sym)
	printf("\n%-15s\texternal override in %s, line %d", " ",
	       strsp+fnametb[symtb[symtb[sym].xfno].modno],
	       symtb[symtb[sym].xfno].lineno);
    } else {
      printf("%-15s\t%s%s%s%s%s symbol defined in %s, line %d", utf8_to_sys(s),
	     (flags&PRIV)?"private ":"",
	     argv?"special ":"",
	     (flags&CST)?"const ":"",
	     (flags&VIRT)?"virtual ":"",
	     (flags&VSYM)?"variable":
	     ((flags&EXT)&&symtb[sym].xfno==sym)?"external function":
	     "function",
	     strsp+fnametb[mno], lineno);
      if ((flags&EXT) && symtb[sym].xfno!=sym)
	printf("\n%-15s\texternal override in %s, line %d", " ",
	       strsp+fnametb[symtb[symtb[sym].xfno].modno],
	       symtb[symtb[sym].xfno].lineno);
    }
    if (type)
      printf("\n%-15s\t%s %s", " ", utf8_to_sys(ts), utf8_to_sys(s));
    else if (argc > 0)
      printf("\n%-15s\t%s", " ", utf8_to_sys(s));
    if (argc > 0) {
      int i;
      for (i = 0; i < argc; i++) {
	printf(" ");
	if (argv && !((argv>>i)&1)) printf("~");
	printf("X%d", i+1);
      }
    }
    if (prec != NONE)
      printf(" @%d", prec);
    if (type) {
      int tmno = symtb[type].modno,
	tlineno = symtb[type].lineno;
      if (tmno == NONE || type < BUILTIN)
	printf("\n%-15s\tbuiltin type %s", " ", utf8_to_sys(ts));
      else
	printf("\n%-15s\t%s%stype %s defined in %s, line %d", " ",
	       (symtb[type].flags&PRIV)?"private ":"",
	       (symtb[type].flags&EXT)?"external ":"", ts,
	       strsp+fnametb[tmno], tlineno);
    } else if (x) {
      printf("\n%-15s\t= ", " ");
      printx(x); flush_shift();
    }
    printf("\n");
  } else
    printf("unknown or bad symbol\n");
  savepos();
  return clean();
}

#define matchsym(fno,s) (!(symtb[fno].flags & TSYM)&&\
			 strcmp((s), strsp+symtb[fno].pname)==0)

static int strhash(char *s, int sz)
{
  unsigned h = 0, g;
  while (*s) {
    h = (h<<4)+*(s++);
    if ((g = (h & 0xf0000000)))	{
      h = h^(g>>24);
      h = h^g;
    }
  }
  return h % sz;
}

static whois(int fno, char *s)
{
  if (strstr(s, "::")) {
    if (fno != NONE) {
      printf("\n(%s)\n", s);
      return whos(fno);
    } else
      return 0;
  } else {
    int fno, k = strhash(s, hashtbsz);
    int modno = (mainno>=0)?mainno:0;
    for (fno = hashtb[k]; fno != NONE; fno = symtb[fno].next)
      if (matchsym(fno, s) &&
	  (symtb[fno].modno == NONE || symtb[fno].modno == modno ||
	   globs[symtb[fno].modno]))
	if (symtb[fno].modno == modno || !(symtb[fno].flags & PRIV)) {
	  char name[MAXSTRLEN];
	  int sym = fno;
	  while (symtb[sym].ref)
	    sym = symtb[sym].ref;
	  if (sym < symtbsz || (symtb[sym].flags & DCL)) {
	    if (symtb[fno].modno >= 0)
	      sprintf(name, "%s::%s", strsp + modtb[symtb[fno].modno],
		      strsp + symtb[fno].pname);
	    else
	      sprintf(name, "::%s", strsp + symtb[fno].pname);
	    printf("\n(%s)\n", name);
	  } else
	    printf("\n");
	  whos(sym);
	}
    return 1;
  }
}

static ambiguous(int fno, char *s)
{
  printf("! whos: Ambiguous symbol `%s'. Alternatives are:\n", s);
  whois(fno, s);
}

/* make the parser reentrant */

static struct {
  int yychar, yynerrs;
  YYSTYPE yylval;
  THREAD *thr;
} yystack[MAXSTACK], *yystptr = NULL;

static yypush()
{
  if (yystptr) {
    if (yystptr - yystack >= MAXSTACK)
      fatal("source stack overflow");
    yystptr->yychar = yychar;
    yystptr->yynerrs = yynerrs;
    memcpy(&yystptr->yylval, &yylval, sizeof(YYSTYPE));
    yystptr->thr = thr;
    yystptr++;
  } else
    yystptr = yystack;
}

static yypop()
{
  if (yystptr > yystack) {
    --yystptr;
    yychar = yystptr->yychar;
    yynerrs = yystptr->yynerrs;
    memcpy(&yylval, &yystptr->yylval, sizeof(YYSTYPE));
    thr = yystptr->thr;
  } else
    yystptr = NULL;
}

/* generic parse routine: */

static parse(source, arg, _mode)
     void	       *source, *arg;
     int		_mode;
{
  int c, actmode;
  long xbp;
  THREAD *_thr = get_thr();
  actmode = _thr->mode;
  xbp = _thr->xsp-_thr->xst;
  if (!initlex(source, arg, _mode)) {
    _thr->qmstat = STACK_OVF;
    return 0;
  };
  yypush();
  thr = _thr;
  thr->mode = 1;
  if (_mode == INTERACT || _mode == SOURCE)
    base = (char*)source;
  else
    base = NULL;	
  if (yyparse()) {
    if (_mode == INTERACT || _mode == SOURCE) {
      thr->debug = debug;
      savepos();
    }
    thr->mode = actmode;
    if (_mode == LINE)
      /* skip remainder of input line */
      if (yychar && yychar != 10 && (thr > thr0 || !checkbrk)) skip();
    finilex();
    /* clean up the stack: */
    while (thr->xsp-thr->xst > xbp)
      qmfree(thr, *--thr->xsp);
    yypop();
    return (0);
  } else {
    if (_mode == INTERACT || _mode == SOURCE) {
      thr->debug = debug;
      savepos();
    }
    thr->mode = actmode;
    finilex();
    yypop();
    return (1);
  }
}

/* interface routines: */

int sparsex(char *s)
{
  THREAD *thr = get_thr();
  int ret;
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  ret = parse(s, NULL, STRING);
  if (!ret && thr->qmstat == BAD_OBJ) thr->qmstat = SYNTAX_ERR;
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  return ret;
}

#if defined(HAVE_UNICODE) && defined(HAVE_ICONV)
int fparsex(FILE *fp, iconv_t *ic)
#else
int fparsex(FILE *fp)
#endif
{
  THREAD *thr = get_thr();
  int ret;
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
#if defined(HAVE_UNICODE) && defined(HAVE_ICONV)
  ret = parse(fp, ic, LINE);
#else
  ret = parse(fp, NULL, LINE);
#endif
  if (!ret && thr->qmstat == BAD_OBJ) thr->qmstat = SYNTAX_ERR;
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (ret)
    if (thr == thr0 && checkbrk) {
      qmfree(thr, *--thr->xsp);
      return 0;
    } else
      return 1;
  else
    return 0;
}

int parsesrc(char *fname, int chk)
{
  char *buf;
  FILE *fp;
  THREAD *thr = get_thr();
  if (!chkfile(fname) || !(fp = fopen(fname, "r"))) {
    char msg[MAXSTRLEN];
    sprintf(msg, qmmsg[FILE_NOT_FOUND], fname);
    error(msg);
    return 0;
  }
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  psource = fname;
  actlineno = 0;
  while (!quitflag && thr->qmstat != QUIT && (buf = mygetline(fp, "", 0))) {
    if (eflag) echo(utf8_to_sys(buf));
    if (!parse(buf, NULL, SOURCE)) {
      if (thr->qmstat == BAD_OBJ) thr->qmstat = chk?SYNTAX_ERR:OK;
      clean();
      free(buf);
      fclose(fp);
#ifdef USE_THREADS
      pthread_mutex_unlock(&parse_mutex);
#endif
      return 0;
    }
    free(buf);
    fflush(stderr);
    fflush(stdout);
  }
  fclose(fp);
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  return 1;
}

int parsex(char *s)
{
  THREAD *thr = get_thr();
  int ret;
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  ret = parse(s, NULL, INTERACT);
  if (!ret && thr->qmstat == BAD_OBJ) thr->qmstat = SYNTAX_ERR;
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (!ret)
    return clean();
  else
    return 1;
}
